/*
@license 
 Licensed Materials - Property of IBM
 5724-U18, 5737-M66
 (C) Copyright IBM Corp. 2016,2023 All Rights Reserved.
 US Government Users Restricted Rights - Use, duplication, or disclosure
 restricted by GSA ADP Schedule Contract with IBM Corp.
 */

 
Polymer({
	is: 'maximo-input-card',
	
  	behaviors: [BaseComponent, HTMLEncoder],
  	
  	listeners: {
  		'changed-color' : '_changedColor',
	    'changed-icon' : '_changedIcon'

  	},
  	
    properties: {
    	
    	index: {
    		type: Number,
    		value: 0
    	},
    	
    	label: {
    		type: String,
    		value: ''
    	},
    	
    	descValue: {
    		type: String,
    		value: null
    	},
    	
    	field: {
    		type: Object,
    		value: null
    	},
    	icon:{
	        type: String,
	        value:'Maximo:Warning'
      	},
    	
    	type: {
    		type: String,
    		value: null
    	},
    	
    	_label: {
    		type: String,
    		computed: 'computeLabel(index,inputi, label,loaded)'
    	},

		_labelIndex: {
			type: String,
    		value: null
		},
    	
    	isQuestionRequired: {
    		type: Boolean,
    		value: false,
    		observer: '_requiredChanged'
    	},
    	
    	visible: {
    		type: Boolean,
    		value: true,
    		observer: '_visibleChanged'
    	},

    	requiredStatus: {
    		type: String,
    		value: function() { return $M.localize('uitext','mxapiinspection','no'); }
    	},
    	
    	visibleStatus: {
    		type: String,
    		value: function() { return $M.localize('uitext','mxapiinspection','Yes'); }
    	},
 
    	
    	previewTitle: {
    		type: String,
    		function() { return $M.localize('uitext','mxapiinspection','preview'); }
    	},
    	
    	constructorTypes: {
    		type: Array,
    		value: ['MM','TR','SE','SO','MO','FU', 'SIG','SOD', 'MOD']
    	},
    	
    	isCopy: {
    		type: Boolean,
    		value: false,
    		observer: '_isCopyChange'
    	},
    	rangeValue:{
    		type: Number,
    		value: 0
    	},
    	toValue:{
    		type:Number,
    		value:0
    	},
    	stepValue:{
    		type:Number,
    		value: 0
    	},
    	initialValue:{
    		type: String,
    		value: null
    	},
    	finalValue: {
    		type:String,
    		value:null
    	},
    	option: {
    		type: Object,
    		value: null
    	},
    	optionIndex:{
    		type: Number,
    		value: 0
    	},
    	optionSet: {
    		type: Array,
    		value: []
    	},
    	optionDesc: {
    		type: String,
    		value: null
    	},
    	valuelist:{
    		type:Array,
    		value:[]
    	},
    	validatorcount:{
    		type:Number,
    		value:0
    	},
    	placeholder: {
    		type: String,
    		value: null
    	},
    	inputi: {
    		type: Number,
    		value: 0
    	},
    	loaded: {
    		type:Boolean,
    		value:false
    	},
    	
    	/**
		 * Indicator to show/hide loading
		 */
    	showTypeaheadLoading: {
    		type: Boolean,
    		value: false
    	},
    	
    	/**
		 * Flag to to indicate if there's type ahead result
		 */
    	hasTypeAheadResult: {
    		type: Boolean,
    		value: false
    	},
    	
    	/**
		 * Type ahead value
		 */
    	meterNameValue: {
    		type: String,
    		value: ''
    	},
    	
    	/**
		 * type ahead result set
		 */
    	typeAheadResultSet: {
    		type: Array,
    		value: []
    	},
    	
    	/**
		 * Selected element
		 */
    	selectedElement: {
    		type: Object
    	},
    	
    	/**
    	 * store value of either meter domain or meter measure unit 
    	 */
    	meterDynamicValue: {
    		type: String
    	},
    	
    	/**
    	 * store label domain or unit measure
    	 */
    	meterdDynamicLabel: {
    		type: String
    	},
    	
    	/**
    	 * Show/hide meter info
    	 */
    	hasMeterInfo: {
    		type: Boolean,
    		value: false
    	},
    	
    	/**
    	 * Set of doctypes
    	 */
    	doctypeCollection: {
    		type: Array,
    		observer: '_doctypeCollectionChanged'
    	},
    	
    	/* Arrays for maximo-lookup */
    	 lookupColors: {
	      type: Array,
	      value: [
	    	  ' ', '#FFD791', '#FDE876', '#C8F08F', '#A7FAE6', 
	    	  '#C0E6FF', '#FFD2DD', '#EED2FF', '#FFD2FF', '#DFE9E9'	  
		   	]
	    },
	    
	    lookupIcons: {
	      type: Array,
	      value: [			  
			  ' ', 'icons:check', 'icons:clear', 'icons:error-outline', 'icons:arrow-drop-up', 'icons:arrow-drop-down',
   			  'icons:check-circle', 'icons:cancel', 'icons:error', 'icons:arrow-drop-down-circle',
   			  'icons:favorite-border', 'icons:favorite', 'icons:star', 'icons:star-border',  'icons:settings',
   			  'icons:refresh', 'icons:build', 'social:mood', 'social:mood-bad', 'icons:thumb-down', 'icons:thumb-up',
   			  'action-based:close', 'action-based:warn', 'object-based:recommendation'
		 ]
		},
		
	},
	ready: function() {
		 
	},
	
	attached: function() {
		this._placeField();
		this.highlight();
	},
	
	computeLabel: function (index,inputi,label,loaded) {
		if(inputi === 0 && loaded === false){
			this._labelIndex = index+1;
			return (index+1) + '. ' + label;
			// this.loaded=true;
		}
		else{
			this._labelIndex =  inputi+1;
			return (inputi+1) + '. ' + label;
		}
	},

	computeOptionLabel: function (index) {
		var cArray=[];
		var nodeArray = Polymer.dom(this.$.optionsHolder).querySelectorAll('.optioninput');
			for (var i = 0; i <= nodeArray.length; i++) {
				if(this.optionSet[i] && !this.optionSet[i].isDeleted){
					cArray.push(this.optionSet[i]);
				}
			}
		this.arrayLength= (cArray.length===0)?1:cArray.length;
		return this.arrayLength;
	},
	
	_fireDelete: function (e) {
		
		this.fire('delete-input');
	},
	
	_fireCopy: function (e) {
		this.updateObjectAttributes();
		this.fire('clone-input');
	},
	
	/**
	 * Required field observer
	 */
	_requiredChanged: function(newV) {
		if (newV === true) {
			this.requiredStatus = $M.localize('uitext','mxapibase','Yes');
			this.visible = true;
		} else {
			this.requiredStatus = $M.localize('uitext','mxapibase','No');
		}
	},
	
	/**
	 * Visible field observer
	 */
	_visibleChanged: function(newV) {
		if (newV === true) {
			this.visibleStatus = $M.localize('uitext','mxapibase','Yes');
		} else {
			this.visibleStatus = $M.localize('uitext','mxapibase','No');
			this.isQuestionRequired = false;
		}
	},
	
	
	_placeField: function() {
		
		if (!this.field) {
			console.warn('No field set.');
			return;
		}
		
		if (this.field.hasOwnProperty('isCopy')) {
			this.isCopy = this.field.isCopy;
		}
		
		this._buildConstructor();
		
	},
	refreshIndexes:function(){
		var nodeArray = Polymer.dom(this.$.optionsHolder).querySelectorAll('.optionlabel');
		var newindex=0;
		var optionLabel;
			for (var i = 0; i < nodeArray.length; i++) {
				if(!this.optionSet[i].isDeleted){
					nodeArray[i].innerHTML= HTMLEncoder.encode(newindex+1)+': ';
					newindex++;
				}
			}
	},
	_unsetCopy: function(e) {
		if (this.isCopy === true){
			this.isCopy = false;
		}
	},
	
	_isCopyChange: function (newV) {

		var copyNode = this.$.copyIcon;
		if (newV === true){
			copyNode.classList.add('copy');
		}else {
			copyNode.classList.remove('copy');
		}
	},
	
	/**
	 * Dispatch to correct constructor
	 */
	_buildConstructor: function() {
		
		if (!this.field.fieldtype_maxvalue) {
			console.error('Unable to build card. Value type missing.');
		}
		
		var type = this.field.fieldtype_maxvalue;
		
		if (this.constructorTypes.indexOf(type) < 0){
			console.error('There is no constructor for this type of input. Input: ' + type);
		}

		if(this.field.optSet){
			this.set('optionSet',this.field.optSet);
			this.optionSet.sort(function(a, b) {
					return parseFloat(a.sequence) - parseFloat(b.sequence);
					});

		}else{
			var optSet=[];
			optSet.push({
				'description':''
			});
			optSet.push({
				'description':''
			});
			this.set('optionSet',optSet);
		}
		
		if ( this.field.description && this.field.description.length > 0 ) {
			this.descValue = this.field.description;
		}
		
		if ( this.field.hasOwnProperty('required') ) {
			this.isQuestionRequired = this.field.required;
		}
		
		if ( this.field.hasOwnProperty('visible') ) {
	 	    this.visible = this.field.visible;
		}
	 	
		switch (type) {
			case 'MM':
				this._mountMeterResponse();
				break;
			case 'TR':
				this._mountTextResponse();
				break;
			// case 'NR':
			// this._mountNumericRange();
			// break;
			case 'SE':
				this._mountNumericEntry();
				break;
			case 'SO':
				this._mountOptionSelect();
				break;
			case 'MO':
				this._mountOptionSelect();
				break;
			case 'FU':
				this._mountFileUpload(type);
				break;
			case 'SIG':
				this._mountFileUpload(type);
				break;
			case 'DO':
				this._mountDateEntryResponse(type);
				break;
			case 'TO':
				this._mountDateEntryResponse(type);
				break;
			case 'DT':
				this._mountDateEntryResponse(type);
				break;
			case 'SOD':
				this._mountDomainResponse(type);
				break;
			case 'MOD':
				this._mountDomainResponse(type);
				break;
			default:
				console.warn('No type matching');
		}
		
	},
	
	/**
	 * Create constructor and preview for Meter Response
	 */
	_mountMeterResponse: function() {
		// Find holder
		var holderNode = this.$.mrOptionHolder;
		
		if (this.field.metername) {
			this.meterNameValue = this.field.metername;
			this.fetchMeterInfo(this.meterNameValue);
		}
		
		var buildContent = Polymer.dom(holderNode).querySelector('.build');
		while (buildContent.childNodes.length > 0) {
			Polymer.dom(this.$.constructor).appendChild(buildContent.childNodes[0]);
		}

		//this.$.previewSection.remove();
		var previewContent = Polymer.dom(holderNode).querySelector('.prev');
		while (previewContent.childNodes.length > 0) {
			Polymer.dom(this.$.preview).appendChild(previewContent.childNodes[0]);
		}
		
		this.previewTitle = $M.localize('uitext','mxapiinspection','example');
		$j(this.$.itemList).css({'display':'none'});
		
	},
	
	/**
	 * Create constructor and preview for Single Option - Lookup Domain
	 */
	 _mountDomainResponse: function() {
		// Find holder
		var holderNode = this.$.domainOptionHolder;
		
		if (this.field.domainid) {
			this.domainValue = this.field.domainid;
			this.fetchDomainInfo(this.domainValue);
		}

		var buildContent = Polymer.dom(holderNode).querySelector('.build');
		while (buildContent.childNodes.length > 0) {
			Polymer.dom(this.$.constructor).appendChild(buildContent.childNodes[0]);
		}

		//this.$.previewSection.remove();
		var previewContent = Polymer.dom(holderNode).querySelector('.prev');
		while (previewContent.childNodes.length > 0) {
			Polymer.dom(this.$.preview).appendChild(previewContent.childNodes[0]);
		}
		
		this.previewTitle = $M.localize('uitext','mxapiinspection','example');
		$j(this.$.itemList).css({'display':'none'});
		
	},


	/**
	 * Create constructor and preview for Text Response
	 */
	_mountTextResponse: function() {
		// Find holder
		var holderNode = this.$.trOptionHolder;
		
		var buildContent = Polymer.dom(holderNode).querySelector('.build');
		while (buildContent.childNodes.length > 0) {
			Polymer.dom(this.$.constructor).appendChild(buildContent.childNodes[0]);
		}
		
		var previewContent = Polymer.dom(holderNode).querySelector('.prev');
		while (previewContent.childNodes.length > 0) {
			Polymer.dom(this.$.preview).appendChild(previewContent.childNodes[0]);
		}
		
		this.previewTitle = $M.localize('uitext','mxapiinspection','example');
		
	},
	
	/**
	 * Create constructor and preview for File Upload
	 */
	_mountFileUpload: function (type) {
		// Find holder
		if (type === 'FU'){
			var holderNode = this.$.fuOptionHolder;
			this.descValue = $M.localize('uitext','mxapiinspection','upload_attachment');
		}
		if (type === 'SIG'){
			var holderNode = this.$.sigOptionHolder;
		}

//		if (this.field.doctype) {
//			this.doctypeValue = this.field.doctype;
//		}

		var buildContent = Polymer.dom(holderNode).querySelector('.build');
		while (buildContent.childNodes.length > 0) {
			Polymer.dom(this.$.constructor).appendChild(buildContent.childNodes[0]);
		}
		
		var mxText = this.$.constructorSection.querySelector('maximo-text');


		if (type === 'SIG'){
			mxText.hidden = false;
		} else {
			mxText.hidden = true;
		}
		//this.$.questionPartDesc.hidden = true;
		
		var previewContent = Polymer.dom(holderNode).querySelector('.prev');
		while (previewContent.childNodes.length > 0) {
			Polymer.dom(this.$.preview).appendChild(previewContent.childNodes[0]);
		}
		
		this.previewTitle = $M.localize('uitext','mxapiinspection','example');
	},

	/**
	 * Observer for doctypeCollection
	 */
	_doctypeCollectionChanged: function(newv, oldv) {
		
		if (this.field.doctype) {
			this.doctypeValue = this.field.doctype;
		}
		
		var selectorValues = '';
		if (newv && newv.length > 0) {
			selectorValues = newv.map(function(element) { return element.doctype; });
			selectorValues = selectorValues.join(',');
		}
		this.$.fuDocTypeSelector.values = selectorValues;
		this.$.sigDocTypeSelector.values = selectorValues;
	},
	
	/**
	 * Create constructor and preview for Numeric Entry
	 */
	_mountNumericEntry: function() {
		// Find holder
		var holderNode = this.$.neOptionHolder;
		
		var buildContent = Polymer.dom(holderNode).querySelector('.build');
		while (buildContent.childNodes.length > 0) {
			Polymer.dom(this.$.constructor).appendChild(buildContent.childNodes[0]);
		}
		
		var previewContent = Polymer.dom(holderNode).querySelector('.prev');
		while (previewContent.childNodes.length > 0) {
			Polymer.dom(this.$.preview).appendChild(previewContent.childNodes[0]);
		}
		
		this.previewTitle = $M.localize('uitext','mxapiinspection','example');
		
	},

	_mountOptionSelect:function(){
		var holderNode = this.$.soOptionHolder;
		var buildContent = Polymer.dom(holderNode).querySelector('.build');
		
		
		// Copy optSet to optionSet - defect 319835
		if(this.field.optSet){
			var copyOptionSet = JSON.parse(JSON.stringify(this.field.optSet));
			this.set('optionSet', copyOptionSet);
			this.optionSet.sort(function(a, b) {
			return parseFloat(a.sequence) - parseFloat(b.sequence);
			});
		} else{
			var optSet=[];
			optSet.push({
			'description':''
			});
			optSet.push({
			'description':''
			});
			this.set('optionSet',optSet);
		}
		
		while (buildContent.childNodes.length > 0) {
			Polymer.dom(this.$.constructor).appendChild(buildContent.childNodes[0]);
		}
		
		this.previewTitle = $M.localize('uitext','mxapiinspection','example');
		
		this._loadPreviewItems();

		this.selectObserver();
		
		this.$.inspectionOptionSet.render();
		
		this._iconHandler();
		
		this._hideDeletedOptions();

	},
	
	_loadPreviewItems: function(){
		
		var preview = this.$.preview;
		while (preview.firstChild) {
		   preview.removeChild(preview.firstChild);
		}
		
		if (this.optionSet  && this.optionSet !== undefined){
			var placeholdertext;
			var responseField;
			var prevIndex = 0;
			var icon;
			var iconNode;
			var divPreviewItem;
			
			var divIcon;

			for(var j=0;j<this.optionSet.length;j++){
				
				if ((this.optionSet[j].description == '') ||
					    (this.optionSet[j].description == undefined) ){
						placeholdertext = $M.localize('uitext','mxapiinspection','option_x',[prevIndex+1]);
				} else {
					placeholdertext = this.optionSet[j].description;
				}
				
				divPreviewItem = Polymer.Base.create('div', {'id': 'divPreviewItem'});	
				divPreviewItem.classList.add('divPreviewItemClass');
				
				divPreviewItem.style.borderColor = this.getComputedStyleValue('--Primary-blue40');
				
				responseField = Polymer.Base.create('maximo-text',{'id':'previewoptioninput','placeholder': placeholdertext});
				responseField.classList.add('exampleTextClass');

				$j(responseField.$.input).attr('readonly','readonly');
				
				Polymer.dom(this.$.preview).appendChild(divPreviewItem);
				
				if (this.optionSet[j].icon && (this.optionSet[j].icon != " ")){
					icon = this.optionSet[j].icon;
					iconNode = Polymer.Base.create('iron-icon',{'icon':icon});
					iconNode.classList.add('itemPrevIcon');
					
					divIcon = Polymer.Base.create('div');
					divIcon.classList.add('divIcon');
					
					divPreviewItem.appendChild(divIcon);
					divIcon.appendChild(iconNode);

					divPreviewItem.appendChild(responseField);
					
				} else {
					divPreviewItem.appendChild(responseField);
					
				}

				if ((this.optionSet[j].color) && !(this.optionSet[j].color === " ")){
					color = this.optionSet[j].color;
					divPreviewItem.style.backgroundColor = color;
					divPreviewItem.style.borderColor = color;
				} else {
					divPreviewItem.style.backgroundColor = this.getComputedStyleValue('var(--Primary-white');
					divPreviewItem.style.borderColor = this.getComputedStyleValue('--Primary-blue40');
				}
				
				if(!this.optionSet[j].isDeleted){
				  prevIndex++;
				} else {
					divPreviewItem.style.display = "none";
				}

			};
		};		
		
	},
	
	highlight: function() {
		var card = this.$.card;
		
		card.classList.add('highlight');
		this.scrollIntoView(false);
		setTimeout(function() {
			card.classList.remove('highlight');
		}, 4000);
	},
	
	/**
	 * Change question required status
	 */
	switchRequired: function(isRequired) {
		if (this.isQuestionRequired !== isRequired) {
			this.isQuestionRequired = isRequired;
		}
	},
	
	/**
	 * Applies suffix to user input to show label in preview mode
	 */
	computePreviewLabel: function (label){
		
		if (label) {
			return label;
		}else {
			return '';
		}
	},
	
	/**
	 * Updates attributes to field property and sends field object
	 */
	fetchResponseFieldObject: function() {
		this.updateObjectAttributes();
		return this.field;
	},
	
	/**
	 * Set properties back to original record
	 */
	updateObjectAttributes: function() {
		this.field.description = this.descValue;
		this.field.required = this.isQuestionRequired;
		this.field.skipoption = !this.isQuestionRequired;
		this.field.visible = this.visible;
		
		this.field.showdate = false;
		this.field.showtime = false;
		
		if(!this.field.fieldtype_maxvalue === 'SO' && !this.field.fieldtype_maxvalue === 'MO'){
			this._clearAttributesFromCopy();
			this.optionSet=this.field.inspfieldoption;
			
		}
		
		if(this.field.fieldtype_maxvalue === 'SO' || this.field.fieldtype_maxvalue === 'MO'){
			this.grabOptions();
			this.field.inspfieldoption=this.optionSet;
			this._clearAttributesFromCopy();			
		}
		
		if(this.field.fieldtype_maxvalue === 'MM'){
			
			if (this.selectedElement && this.selectedElement.hasOwnProperty('metername')) {
				this.field.metername = this.selectedElement.metername;
				this.field.metertype = this.selectedElement.metertype;
			}else {
				return;
			}
		}

		if( (this.field.fieldtype_maxvalue === 'SOD') || (this.field.fieldtype_maxvalue === 'MOD') ){
			
			if (this.selectedElement && this.selectedElement.hasOwnProperty('domainid')) {
				this.field.domainid = this.selectedElement.domainid;
				this.field.domaintype = this.selectedElement.domaintype;
			}
		}
		// File Upload set doctype attribute
		if ((this.field.fieldtype_maxvalue === 'FU') || this.field.fieldtype_maxvalue === 'SIG') {
			this.field.doctype = this.doctypeValue;
		}
	},
	
	/**
	 * DragNDrop tests
	 */
	
	_addDragProp: function (e) {
		this.$.card.draggable = true;
	},
	
	_removeDragProp: function (e) {
		this.$.card.draggable = false;
	},
	
	_handleDragEnter: function (e) {
		e.preventDefault();
		this.$.card.classList.add('dashedBorder');
	},
	
	_handleDragLeave: function (e) {
		console.log('leaves a valid drop target.');
		this.$.card.classList.remove('dashedBorder');
	},
	_iconHandler:function(){
		var iconHolder=Polymer.dom(this.$.optionsHolder).querySelectorAll('.optionminus');
		var arrayOptions=[];
		for (var i = 0; i < this.optionSet.length; i++) {
			if(!this.optionSet[i].isDeleted){
				arrayOptions.push(this.optionSet[i]);
			}
		}
		
		//It´s possible to have only one option in the list
		if(arrayOptions.length>1){
			for (var i = 0; i < iconHolder.length; i++) {
				$j(iconHolder[i]).css({'fill':'#4178be'});
			}
		}
		else{
			for (var i = 0; i < iconHolder.length; i++) {
				$j(iconHolder[i]).css({'fill':'black'});
			}
		}
	},

	_addOption:function(e) {
		// var deleteXElements = 0;
    	//var newElementIndex = e.model.index + 1;
    	var element = e.model.option;
    	//this.optionIndex=newElementIndex;
        var copiedelement=JSON.parse(JSON.stringify(element));
		
		delete copiedelement.inspfieldoptionid;
		delete copiedelement.href;
		delete copiedelement.sequence;
		delete copiedelement.description;
		delete copiedelement.inspectorfeedback;
		delete copiedelement.requireaction;
		delete copiedelement.isDeleted;
		delete copiedelement.icon;
		delete copiedelement.color;
		delete copiedelement.domainid;
		delete copiedelement.domaintype;

    	// this.splice('optionSet', newElementIndex, deleteXElements,
		// copied element);
    	this.push('optionSet',copiedelement);
		
		var count=0;
		for (var i = 0; i <this.optionSet.length; i++) {
			if(!this.optionSet[i].isDeleted){
				count++;
			}
		}
		if(count>2){
			var nodeArray = Polymer.dom(this.$.optionsHolder).querySelectorAll('.optionminus');
			for (var j =0; j<nodeArray.length; j++) {
				nodeArray[j].classList.add('optionminusactive');
			}
		}
		
		placeholdertext = $M.localize('uitext','mxapiinspection','option_x',[count]);	
		
        // add Preview Item
		divPreviewItem = Polymer.Base.create('div', {'id': 'divPreviewItem'});				
		divPreviewItem.classList.add('divPreviewItemClass');
		
		var responseFieldPreview = Polymer.Base.create('maximo-text',{'id':'previewoptioninput','placeholder': placeholdertext});
		responseFieldPreview.classList.add('exampleTextClass');
		
		divPreviewItem.style.borderColor = this.getComputedStyleValue('--Primary-blue40');
		
		$j(responseFieldPreview.$.input).attr('readonly','readonly');
		
		Polymer.dom(this.$.preview).appendChild(divPreviewItem);
		
		divPreviewItem.appendChild(responseFieldPreview);

		this.$.inspectionOptionSet.render();
		this._iconHandler();
		this.selectObserver();


	},
	
	   _removeOption:function(e) {
			
		   
		    var count=0;
			for (var i = 0; i <this.optionSet.length; i++) {
				if(!this.optionSet[i].isDeleted){
					count++;
				}
			}

			if(count>1){
				var index = e.model.index;

				if (e.model.option.description == undefined){
						e.model.option.description = '';	
				}
				
				e.model.option.isDeleted=true;
		        e.target.closest('.options').style.display='none';
				this.notifyPath('option.isDeleted');
				count--;

				this.refreshIndexes();
				this._iconHandler();
				this.selectObserver();
				this.$.inspectionOptionSet.render();
				
			}

			this._loadPreviewItems();
			
		},

	grabOptions: function(){
    	var optionsequence = this.optionSet;
    	this.optionSet=[];
		for (var i = 0; i < optionsequence.length; ++i) {
			optionsequence[i].sequence = i + 1;
			this.push('optionSet',optionsequence[i]);
		}
    },
	
    optionValidator: function(b){
		var nodeArray=Polymer.dom(this.$.optionsHolder).querySelectorAll('input.optioninput');
    	var optHolder=Polymer.dom(this.$.optionsHolder).querySelectorAll('.options');
    	var iconHolder=Polymer.dom(this.$.optionsHolder).querySelectorAll('.validationicon');
    	var count=0;
    	var validatemsg='';
    	
     	var duplicates = this.validateDuplicates(nodeArray);
     	
     	for(var i=0; i<nodeArray.length;i++){
     	
  		if(nodeArray[i].id.indexOf('message')===-1){
  			if( (b === true) && ((nodeArray[i].value === ''))){	
    			
  				if(!this.optionSet[i].isDeleted === true){
    				$j(optHolder[i]).css({'position':'relative'});
    				$j(iconHolder[i]).css({'display':'inline-block','position':'relative','width':'50px','pointer-events':'none','right':'61%'});
    				$j(nodeArray[i]).css({'padding-left':'30px','border-color':'#d74108'});
    				count++;
					validatemsg = 'validationmsg';
    			}
    			
	        } else {
	        	
	        	if( (b === true) && (duplicates.includes(nodeArray[i].value.trim().toLowerCase()))){
	 				if((!this.optionSet[i].isDeleted === true)){
	    				$j(optHolder[i]).css({'position':'relative'});
	    				$j(iconHolder[i]).css({'display':'inline-block','position':'relative','width':'50px','pointer-events':'none','right':'61%'});
	    				$j(nodeArray[i]).css({'padding-left':'30px','border-color':'#d74108'});
	    				count++;
						validatemsg = 'duplicatedoptions';
	    			}

	        	}
	        }
  			
    	}
    		else{
    		$j(iconHolder[i]).css({'display':'none'});
      		$j(nodeArray[i]).css({'padding-left':'3px','border-color':'#aeb8b8'});
    		}
    	}

     	return validatemsg;
    },
    
    
    validateDuplicates: function(nodeArray){
    	
   		    var valuesArray = [];
  		    var dup = [];
  		    for (var i = 0; i < nodeArray.length; ++i) {
  		    	var value = nodeArray[i].value.trim().toLowerCase();
  		        if (valuesArray.indexOf(value) !== -1) {
   		        	dup.push(value);
  		        } else {
  		        	valuesArray.push(value);
  		        }
  		    }
  		    return dup;
    	
    },	
    	
    	
    selectObserver:function(event){
    	// var test=this.fetchResponseFieldObject();
    	var res = [];
    	if (event && event.target && event.target.id){
    	  this.optionSet[parseInt(event.target.id)].requireaction = Boolean(event.detail);
    	}
    	var e =this.optionSet;
    	for (var i = 0; i <e.length; i++) {
    	  var inspfieldoption= e[i];
  			if(!inspfieldoption.isDeleted){
  				res.push(inspfieldoption.description);
  				res.push(inspfieldoption.inspectorfeedback);
  				res.push(inspfieldoption.requireaction);	
			  }
    	}
			this.optionValidator(false);
			this.valuelist = res.join(',');

			if (event && event.target) {
				// Resize input width
				var input = event.target;
				var inputWidth = 0;
				if(input.value){
					inputWidth = input.value.length;
				}
				input.style.width = ((inputWidth + 1) * 8) + 'px';
			}
			
			
    },
    
    /**
     * Validate input card
     * 
     * return Boolean
     */
    validate: function() {
    	
    	var type = this.field.fieldtype_maxvalue;
    	
    	if(type === 'MM'){
    		if ( !this.meterNameValue ) {
    			//this.$.meterNameInputText.validator(this.$.meterNameInputText, true);
    			return false;
    		}else {
    			//this.$.meterNameInputText.validator(this.$.meterNameInputText, false);
				if (!this.hasMeterInfo){
                    return  false;
                }
    		}
    	} else if ( (type === 'FU') || (type === 'SIG')) {
			if (!this.doctypeValue) {
				return false;
			}
		} else if ( (type === 'SOD') || (type === 'MOD')){
			if ( !this.domainValue ) {
    			return false;
    		}
    	}
    	
    	return true;
    },
    
    /**
     * Observe changes on file upload selector
     */
    _doctypeChanged: function(e) {
    	this.doctypeValue = e.target.value;
    },
    
    /**
	 * Refresh collection based on input
	 */
	searchMeter: function (e) {
		
		// console.log('Listens to input: ' + this.meterNameValue);

		var input = e.currentTarget;
		
		if (!this.meterNameValue) {
			this.selectedElement = null;
			this.hasMeterInfo = false;
		}
		
		if (!this.meterNameValue || !this.meterNameValue.trim()){
			$j(this.$.itemList).css({'display':'none'});
			if(input.keyupTimer){
				window.clearTimeout(input.keyupTimer);
			}
			return;
		}else{
			this.showTypeaheadLoading = true;
			$j(this.$.itemList).css({'display':'block'});
		}

		if(input.keyupTimer){
			window.clearTimeout(input.keyupTimer);
		}
		
		var that = this;
	    input.keyupTimer = setTimeout(function(){
	    	that.performSearch();
		}, 1000);
		
	},
	
	/**
	 * Prepare conditions and trigger a collection refresh
	 */
	performSearch: function () {
		
		// IJ35027 - For searching terms, using the """ to a Literal Search, including spaces, but removing 
		// the spaces in the beginning and in the end of the search string
		this.searchTerms = '"' + '%' + (this.meterNameValue? this.meterNameValue.trim():"")+ '%' + '"';

		this.$.meterCollection.refreshRecords();
	},
	
		/**
	* Refresh collection based on input
	*/
	searchDomain: function (e) {
		var input = e.currentTarget;
		
		if (!this.domainValue) {
			this.selectedElement = null;
		}
		
		if (!this.domainValue || !this.domainValue.trim()){
			$j(this.$.domainItemList).css({'display':'none'});
			if(input.keyupTimer){
				window.clearTimeout(input.keyupTimer);
			}
			return;
		}else{
			this.showTypeaheadLoading = true;
			$j(this.$.domainItemList).css({'display':'block'});
		}
		
		if(input.keyupTimer){
			window.clearTimeout(input.keyupTimer);
		}
		
		var that = this;
		input.keyupTimer = setTimeout(function(){
			that.performDomainSearch();
		}, 1000);
		
	},

	/**
	 * Prepare conditions and trigger a collection refresh
	 */
	 performDomainSearch: function () {
		
		this.searchTerms = '"' + '%' + (this.domainValue? this.domainValue.trim():"")+ '%' + '"';
		this.$.domainCollection.refreshRecords();
	},
	/**
	 * Typeahead collection success handler
	 */
	_handleDataRefreshed: function(e) {
		
		$j(this.$.itemList).css({'display':'block'});
		
		this.typeAheadResultSet = this.$.meterCollection.collectionData;
		if (this.typeAheadResultSet && this.typeAheadResultSet.length > 0) {
			this.hasTypeAheadResult = true;
		}else {
			this.hasTypeAheadResult = false;
		}
		
		var that = this;
		setTimeout(function(){ that.showTypeaheadLoading = false; }, 500);
	}, 
	
	/**
	 * Typeahead collection error handler
	 */
	_handleDataError: function(e) {
		this.showTypeaheadLoading = false;
		
		$j(this.$.itemList).css({'display':'block'});
		console.error('Problems to execute query');
	},
	

	/**
	 * Typeahead collection success handler
	 */
	 _handleDomainDataRefreshed: function(e) {

		$j(this.$.domainItemList).css({'display':'block'});
		
		this.typeAheadResultSet = this.$.domainCollection.collectionData;
		if (this.typeAheadResultSet && this.typeAheadResultSet.length > 0) {
			this.hasTypeAheadResult = true;
		}else {
			this.hasTypeAheadResult = false;
		}
		
		var that = this;
		setTimeout(function(){ that.showTypeaheadLoading = false; }, 500);
	}, 

	/**
	 * Typeahead collection error handler
	 */
	 _handleDomainDataError: function(e) {
		this.showTypeaheadLoading = false;
		
		$j(this.$.domainItemList).css({'display':'block'});
		console.error('Problems to execute query');
	},
	/**
	 * Compute asset description
	 */
	_getElemDesc(item) {
		return item.description + ' (' + item.metername + ')';
		//return  item.metername;
    },
    
	/**
	 * Compute asset description
	 */
	 _getDomainElemDesc(item) {
		return item.description + ' (' + item.domainid + ')';
	},

    /**
	 * Listens to type ahead option list
	 */
	_selectElement: function(e){
		
		// Store selected element in var
		this.selectedElement = e.model.elem;
		//this.descValue = this.selectedElement.description;
		this._unsetCopy();
		//this.meterNameValue = this._getElemDesc(this.selectedElement);
		this.meterNameValue = this.selectedElement.metername;
		
		if (this.selectedElement.measureunitid) {
			this.meterdDynamicLabel = $M.localize('uitext', 'mxapiinspection','unit_measure'); 
			this.meterDynamicValue = this.selectedElement.measureunitid;
		}else {
			this.meterdDynamicLabel = $M.localize('uitext', 'mxapiinspection','domain_name'); 
			this.meterDynamicValue = this.selectedElement.domainid;	
		}
		
		// $j(this.$.mrBuildMeterUnitDomain).css({'display':'block'});
		this.hasMeterInfo = true;
		$j(this.$.itemList).css({'display':'none'});
		
	},

	/**
	 * Listens to type ahead option list
	 */
	 _selectDomainElement: function(e){
	
		// Store selected element in var
		this.selectedElement = e.model.elem;

		this._unsetCopy();
		this.domainValue = this.selectedElement.domainid;
		this.domaintype = this.selectedElement.domaintype;

		$j(this.$.domainItemList).css({'display':'none'});
		
	},

	/**
	 * fetching meter info
	 */
	fetchMeterInfo: function(metername) {
		
		var maximoQbe = new MaximoQbe();
		maximoQbe.setEquals('metername', metername);
		
		var qbeObject = maximoQbe.toJSON();
		this.$.meterInfo.queryWhere = qbeObject;
		
		this.$.meterInfo.refreshRecords();
	},

	/**
	 * fetching maximo domain info
	 */
	 fetchDomainInfo: function(domainid) {

		var maximoQbe = new MaximoQbe();
		maximoQbe.setEquals('domainid', domainid);
		
		var qbeObject = maximoQbe.toJSON();
		this.$.domainInfo.queryWhere = qbeObject;
		
		this.$.domainInfo.refreshRecords();
	},
	/**
	 * Create constructor and preview for Date Time Response
	 */
	_mountDateEntryResponse: function(type) {
		var holderNode='';
		// Find holder
		if(type==='DO'){
			holderNode = this.$.doOptionHolder;
		}
		if(type==='DT'){
			 holderNode = this.$.dtOptionHolder;
		}
		if(type==='TO'){
			 holderNode = this.$.toOptionHolder;
		}
		
		var buildContent = Polymer.dom(holderNode).querySelector('.build');
		while (buildContent.childNodes.length > 0) {
			Polymer.dom(this.$.constructor).appendChild(buildContent.childNodes[0]);
		}

		var previewContent = Polymer.dom(holderNode).querySelector('.prev');
		while (previewContent.childNodes.length > 0) {
			Polymer.dom(this.$.preview).appendChild(previewContent.childNodes[0]);
		}
		
		this.previewTitle = $M.localize('uitext','mxapiinspection','example');
		$j(this.$.itemList).css({'display':'none'});
	},
	
	/**
	 * Success to retrieve meter info
	 */
	_handleFetchData: function(e) {
		var result = this.$.meterInfo.collectionData;
		let meter = null;
		
		if (result) {
			if (result.length === 1) {
				meter = result[0];
			} else if (result.length > 1) {
				console.warn('Multiple meters found. Filtering by name...')
				meter = result.find(meterResult => meterResult.metername === this.meterNameValue);
			} else {
				console.error('Meter info search fetched ' + result.length);
			}
		}
		
		if (meter) {
			
			this.selectedElement = meter;
			
			if (this.selectedElement.measureunitid) {
				this.meterdDynamicLabel = $M.localize('uitext', 'mxapiinspection','unit_measure'); 
				this.meterDynamicValue = this.selectedElement.measureunitid;
			}else {
				this.meterdDynamicLabel = $M.localize('uitext', 'mxapiinspection','domain_name'); 
				this.meterDynamicValue = this.selectedElement.domainid;	
			}
			this.hasMeterInfo = true;
		}
	},
	
	/**
	 * Success to retrieve meter info
	 */
 	_handleFetchDomainData: function(e) {
		var result = this.$.domainInfo.collectionData;
		let domain = null;
		
		if (result) {
			if (result.length === 1) {
				domain = result[0];
			} else if (result.length > 1) {
				console.warn('Multiple domains found. Filtering by name...')
				domain = result.find(domainResult => domainResult.domainid === this.domainValue);
			} else {
				console.error('Domain info search fetched ' + result.length);
			}
		}
		
		if (domain) {
			this.selectedElement = domain;
		}

	},
	/**
	 * Failed to retrieve meter info
	 */
	_handleFetchDataError: function(e) {
		
	},

	/* Show/Hide Inspector Feedback field in the grid */
    _showInspectorFeedback: function(e){
		 var selectedElement = e.currentTarget.closest('.options').querySelector('.inspector-feedback');
		 if ((selectedElement.style.display === "none") || (selectedElement.style.display === "")){
			selectedElement.style.display = "grid";
		 } else {
			selectedElement.style.display = "none";
		 }
	},
	
	/* Update Preview item when changing the description field */
	updatePreview: function(e){

		var index = e.currentTarget.id.split("_")[0];
		var previewElement = this.$.preview.querySelectorAll('maximo-text').item(index);
		
		//defect 319839
		if ((e.model.option.description == '') ||
			    (e.model.option.description == undefined) ){
			    var previewIndex = e.currentTarget.closest('.options').querySelector('.optionlabel').innerHTML.split(":")[0];
			    previewElement.placeholder =  $M.localize('uitext','mxapiinspection','option_x',[previewIndex]);
		} else {
			previewElement.placeholder = e.model.option.description;
		}
		
		this.selectObserver();
		
	},
	
	/* Compute localized label */
	computeHeaderLabel: function (label){
		if (label) {
			return $M.localize('uitext','mxapiinspection',label);
		}else {
			return '';
		}
	},
	
	_hideDeletedOptions: function(){
		var optArray = this.optionSet; 
		for(var i=0; i<optArray.length;i++){
		   if(optArray[i].isDeleted !== undefined){
			   if(optArray[i].isDeleted === true){
				   $j(optArray[i]).css({'display':'none'});
			   }
			
		   }
		      
		}
	},


	_clearAttributesFromCopy: function(){
		if(this.field.isCopy){
			if(this.field.inspfieldoption){
				for(var i=0;i<this.field.inspfieldoption.length;i++){
	  				delete this.field.inspfieldoption[i].inspfieldoptionid;
	                delete this.field.inspfieldoption[i].href;
	                delete this.field.inspfieldoption[i].inspfieldoptionid_localized;
				}
            }
		}	
		
	},
	
	/* Update Preview item when changing the description field */
	updateIconPreview: function(e){

		var index = e.currentTarget.id.split("_")[0];
		var previewElement = this.$.preview.querySelectorAll('maximo-text').item(index);
		
		//defect 319839
		if ((e.model.option.description == '') ||
			    (e.model.option.description == undefined) ){
			    var previewIndex = e.currentTarget.closest('.options').querySelector('.optionlabel').innerHTML.split(":")[0];
			    previewElement.placeholder =  $M.localize('uitext','mxapiinspection','option_x',[previewIndex]);
		} else {
			previewElement.placeholder = e.model.option.description;
		}
		
		this.selectObserver();
		
	},
	
	/* Update Preview item when changing the color of the description field */
	_changedColor: function(e){

		var index = e.target.id.split("_")[0];
		
		var divElement = this.$.preview.querySelectorAll('.divPreviewItemClass').item(index);
		
		var newColor = e.target.querySelector("input").value;
		
		if (newColor === " "){
			divElement.style.backgroundColor = this.getComputedStyleValue('var(--Primary-white');
			divElement.style.borderColor = this.getComputedStyleValue('--Primary-blue40');
		} else {
			divElement.style.backgroundColor = newColor;
			divElement.style.borderColor = newColor;
		}
		
	},

	
	/* Update Preview item when changing the icon of the description field */
	_changedIcon: function(e){
		
		var index = e.target.id.split("_")[0];		
		var previewElement = this.$.preview.querySelectorAll('.divPreviewItemClass').item(index);	
		
		var newIcon = e.target.querySelector("input").value;
		
		var text = previewElement.querySelector('maximo-text');
	
		if (!(newIcon === " ")){
			var divIcon = previewElement.querySelector('.divIcon');
			if (divIcon){
				divIcon.parentNode.removeChild(divIcon);
			}
			var divIcon = Polymer.Base.create('div');
			
			divIcon.classList.add('divIcon');
			previewElement.appendChild(divIcon);
			
			iconNode = Polymer.Base.create('iron-icon',{'icon':newIcon});
			divIcon.appendChild(iconNode);

			previewElement.querySelector('.divIcon').classList.add('itemPrevIcon');
			
			previewElement.querySelector('maximo-text').setAttribute('style', 'order: 2');
		
		} else {
			var divIcon = previewElement.querySelector('.divIcon');
			if (divIcon){
				divIcon.parentNode.removeChild(divIcon);
			}
			
			previewElement.querySelector('iron-icon').setAttribute('icon', "");
			previewElement.querySelector('maximo-text').classList.add('exampleTextNoIcon');
	
		}
		
	},

	/**
	 * Compute the ID for Option Input Fields
	 * @param {index} index 
	 */
	computeOptionId: function (index) {
		return this._labelIndex + '.' + index;
	},

});
