/*
 * @license
 * Licensed Materials - Property of IBM
 * 5724-U18
 * Copyright IBM Corporation. 2017,2018,2019
 */
Polymer({
	
	is: 'maximo-technician-main',
	
  	behaviors: [BaseComponent,Workorder],
  	
  	listeners: {
  		'showWODetail': '_showWODetail',
  		'goback' : '_goBack',
  		'startAssignment' : '_startAssignment',
  		'beginAssignment' : '_beginAssignment',
  		'finishAssignment' : '_finishAssignment',
  		'stopAssignment' : '_stopAssignment',
  		'refreshAttachments' : '_refreshAttachments',
  		'filtercollection' : '_filtercollection',
  		'reloadAttachments' : '_reloadAttachments',
  		'completeWorkorder' : '_completeWO',
  		'reportWork' : '_reportWork',
  		'reportWorkFromCard' : '_reportWorkFromCard',
  		'goBackandCompleteWO' : '_goBackAndCompleteWO',
  		'domaincollection' : '_domaincollection',
  		'domainlist' : '_domainList',
  		'statusChanged':'_statusChanged',
  		'handleMobileActionFooterNav' : '_handleMobileActionFooterNav',
  		'loadButtons' : '_loadButtons',
  		'page-changed' : '_handleMobileActionFooterNav',
  		'showAssetDetail':'_showAssetDetail',
  		'show-location-detail':'_showLocationDetails',
  		'common-detail-back':'_goBackPage',
  		'updateFooter':'_updateFooter',
  		'loadFailureData' : '_failureDetails',
  		'wo-detail':'_showWODetail',
  		'designer-get-collections' : '_getCardCollections',
  		'create-work-order':'_getNewWorkorderData',
  		'cancel-work-order' : '_cancelWorkorder',
  		'save-work-order' : '_saveWorkorder'
  	}, 
  	
    properties: {
    	
    	/**
    	 * component selected in iron-pages 
    	 */
    	selectedPage: {
    		type: String,
    		value: 'techWOList',
    		observer: '_switchPage'
    	},
    	
    	currentPage: {
    		type: String,
    		value: 'techWOList' 
    	},
    	
    	//Store navigation history
    	historyStack: {
    		type: Array,
    		value: []
    	},
    	
		currentCollection: {
			type: Object
		},
		
		currentTab: {
			type: String,
			notify: true
		},
		
		fullAttributeList: {
			type: String,
			value: 'rel.labtranstimerstatus{*},workorderid,worktype,wo_worktype.wtypedesc,wopriority,schedstart,targstartdate,targcompdate,description,estdur,description_longdescription,wonum,pmnum,assetnum,asset.location,asset.description,location,location.description,status,asset.isrunning,schedfinish,parent.wonum,parent.description,parent.parent,siteid,reportedby,reportdate,owner,ownergroup,onbehalfof,lead,supervisor,location._imagelibref,asset._imagelibref,ownerperson.displayname,ownerperson._imagelibref,onbehalfof.displayname,onbehalfof._imagelibref,reportedby.displayname,reportedby._imagelibref,uxlead.displayname,uxlead._imagelibref,uxsupervisor.displayname,uxsupervisor._imagelibref,glaccount,actstart,actfinish,site.description,istask,taskid'
		},
		
		attributeList: {
            type: String,
            value: 'schedstart,wonum,description,siteid,worktype,wopriority,status,assetnum,asset.description,asset._imagelibref,location.location,location.description,location._imagelibref,rel.labtranstimerstatus{timerstatus,laborcode,starttimeentered,startdateentered},workorderid,moddowntimehist,problemcode,failure.description,problem.description,failurecode,remarkdesc,actfinish,istask,parent.wonum,taskid,reportedby.displayname'
		},
		
		searchAttributesNames: {
		    type: String,
		    readOnly: true,
		    value: 'asset.description,location.description,schedstart,wonum,description,worktype,wopriority,uxsynonymdomain.description'
		},
		
    	startTime : {
			type: String,
		},
		startDate : {
			type: String,
		},
		stopTime : {
			type: String,
		},
		stopDate : {
			type: String,
		},
		
    	/**
    	 * Copy of overdue collection - to be used in attached 
    	 */
		copyOverdueCollection: {
			type: Object,
			value: null
		},
		
		editAsset: {
			type: Boolean,
			value: false
		},
		
		/**
		 * Prevent back action from executing when called from 
		 * Report Actuals, Complete Work order
		 */
		disableBack: {
			type: Boolean,
			value: false
		},
		
    	/**
    	 * LT Type domain filter
    	 */
    	ltTypeDomainFilter: {
    		type: Array,
    		value: function () {
    			return [{'filtertype': 'SIMPLE', 'field': 'domainid', 'availablevalues': [ {'value': 'LTTYPE', 'selected': true} ]}];
    		}
    	}, 	
        contextSubscriptions: {
			value: ['page-changed']
		},
		
		/**
		 * wo Status filter
		 */
		woStatusDomainFilter: {
		    type: Array,
		    value: function () {
		        return [{'filtertype': 'SIMPLE', 'field': 'domainid', 'availablevalues': [ {'value': 'WOSTATUS', 'selected': true} ]}];
		    }
		},
		
		/**
		 * Stores WO status 
		 */
		woStatusSet: {
		    type: Array,
		    value: []
		},
		
		/**
         * DEPRECATED
         */
        displayedCollection: {
            type: Object,
            notify: true
            //observer: '_handleRecordDataRefreshed'
        },
        
        _collectionIDs: {
        	type: Object,
        	value: function(){
        		return {'technicianWOCollection':true,'overduecollection':true,'todaycollection':true,'tomorrowcollection':true,'nextdayscollection':true,'completedcollection':true};
        	}
        },
        
        mbo : {
            type: Object
        },
        /**
		 * bypass the flag for not having toggle
		 */
        bypassFlag :{
        	type :Boolean,
        	value : false
        },
        
        /**
		 * Fail type filter
		 */
		failTypeDomainFilter: {
		    type: Array,
		    value: function () {
		        return [{'filtertype': 'SIMPLE', 'field': 'domainid', 'availablevalues': [ {'value': 'FAILTYPE', 'selected': true} ]}];
		    }
		},
		
		/**
		 * Stores failType set 
		 */
		failTypeSet: {
		    type: Array,
		    value: []
		},
		/** 
		 * prior page.
		 */
		sourcePage: {
			type: String 
		},
		/**
         * save sigoption for the wo
         */
        readAceessGranted: {
           type: Boolean,
           value:true
        }
	},

	/**
	 * Refresh dataset from List view
	 * Stop spinner
	 */
    updateDataSet: function() {
    	this.getTechWOList().dataSetRefresh();
    },

	/**
	 * Goes back to list page
	 */
	_goBack: function (e) {	
		//prevent goback from getting called in certain scenarios.
		this.disableBack = true;
		
		if (this.historyStack.length < 1) {
			this._changePage('techWOList');
			return;
		} 
		if (this.historyStack.length <= 1) {
			$M.workScape.fire('workscape-design-views',{'hasDesignMode':true});
		}else{
			$M.workScape.fire('workscape-design-views',{'hasDesignMode':false});
		}
		
		var pageName = this.historyStack.pop();
		if(pageName==='showAssetDetail' || pageName==='locationDetails'){
			pageName='techWOList';
		}
		this.loadCurrentCollectionAndCounters();
		this._changePage(pageName, true);
	},
	
	/**
	 * Transitions to detail view with selected record.  Loads the attachments for selected WO.
	 */
	_showWODetail: function(e){
		$M.toggleWait(true);
		var record = e.detail.wonum?e.detail:e.detail.record;
		var self = this;
		this.addContent('techWODetail');
		var techWODetail = this.getTechWODetail();
		techWODetail.completeWO = false;
		if (record.wonum){
			if(e.detail.newWO){
				techWODetail.cachedRecord ={};
				techWODetail.createWO = techWODetail.newWO = true;
			}
			this.mbo = record;
			var detailRecord = e.detail.sourcePage ? e.detail : techWODetail;
			if(detailRecord.sourcePage === 'create' && detailRecord.newWO){
				techWODetail.collection = detailRecord.collection;
				techWODetail.record = detailRecord.record;
				techWODetail.mbo = detailRecord.record;
				techWODetail.tempRecordClean = false;
				techWODetail.sourcePage = detailRecord.sourcePage;
				techWODetail.$.wopriority.newTile = detailRecord.newWO;
				if(record.wopriority === undefined){
					techWODetail.$.wopriority.newTile = detailRecord.newWO;
					techWODetail.$.wopriority.emptyRecord = true;
			  	}
			} else {
				techWODetail.createWO = false;
				$j(techWODetail.$.contentSelector).removeAttr('add-class');
				techWODetail._showReportActuals(record.status_maxvalue);
				this._loadAttachments(record);
				
				//reset contentSelector to default
				techWODetail.record=record;
				techWODetail.resetContentSelectorDefault();
			}
			if(techWODetail.createWO){
				$j(techWODetail.$.contentSelector).attr('add-class','disableLink');
				techWODetail._disabledPageNavigation(true);
			}else{
				$j(techWODetail.$.contentSelector).removeAttr('add-class');
				techWODetail._disabledPageNavigation(false);
			}
			techWODetail.$.workfailure.newTile = detailRecord.newWO;
			techWODetail.$.workproblem.newTile = detailRecord.newWO;
			var dataKey= $j(techWODetail).find('[data-key]');
			$j(dataKey).each(function(index,elem){
				 elem.newTile = detailRecord.newWO;
				 $j(elem).find('.hideAddElement').show(); 
			});
						
			techWODetail._showHideSection('section_details');
			techWODetail._loadMultiAssetLocData();
	  		$j(window).on('resize', function(){
	    		window.clearTimeout(this.resizeTimer);
	    		self.resizeTimer = window.setTimeout(function(){
		  			if(techWODetail.disableActions===false){
		  				self._handleMobileActionFooterNav();
		  			}
	    		}, 100);
	  			
			});
	  		
	  		//manage page navigation
    		this.$.pages.stopAnimation = true;
	  		this._changePage('techWODetail');
	  		setTimeout(function(){ 
	  			self._handleMobileActionFooterNav();
 	 		}, 200);
			
			techWODetail.refreshTiles();
			if(!$M.wasTourRun('TECHDETAIL') && $M.showTourManual && !$M.isTourDisabled){
	    		$M.toggleWait(true);
	    		this.async(function(){
	    			$M.showTour('TECHDETAIL');
	    		},500);
	    		
			}
			if(techWODetail.createWO){
				$M.toggleWait(false);
			}
			techWODetail._setRequiredTile();
	  		setTimeout(function(){ 
				techWODetail._disableSaveButton();
 	 		}, 200);
			$M.workScape.fire('workscape-design-views',{'hasDesignMode':false});
		}else{
			console.log('cant show wo detail: no work order number');
		}
	},
	
	/**
	 * Renders Report Actual page.
	 */
	_reportWork : function(e){
		this.stopClicked = false;
		var record = e.detail;
		if(!this.getReportWork()){
			this.addContent('techReportWork');
		}
		this.getReportWork().cameFromCard = false;
		this._goToReportWork(record);
	},
	
	/**
	 * Renders Report Actual page.
	 */
	_goToReportWork : function(record){
		
		if(!this.getReportWork()){
			this.addContent('techReportWork');
		}
		
		if (record){
			this.mbo = record;
			var techReportWork = this.getReportWork();
			techReportWork.isWorkOrderComp=record.isWorkOrderComp;
			techReportWork._firstLoad = true;
			techReportWork.totalAssignmentCount = -1;
			//load actualLabor time or assignments based on count
			techReportWork.checkAssignments();
			
			//manage page navigation
	  		this._changePage('techReportWork');
	  				
			//set background color
			$j("div[name*='techReportWork']")[0].style.backgroundColor='#ffffff';
		}
	},
	
	
	/**
	 * Renders Report Actual page, set the back button as enable 
	 */
	_reportWorkFromCard: function(e){
		this._goToReportWork(e.detail);
		this.getReportWork().cameFromCard = true;
		e.detail.startClicked = false;
	},
	
	/**
	 * Load domain dependencies to build list filters
	 */
	attached: function() {

	    //Fires woStatusDomain
	    this.$.woStatusDomain.refreshRecords();
	    this.$.failTypeDomain.refreshRecords();
	    this.addContent('techWODetail');
	    $M.workScape.backTopHide = true;
	    this.readAceessGranted = this.isAuthorized('MXAPIWODETAIL:READ');
	},
	
	/**
	 * Trigger counter of all collections
	 * Fetch records of the current collection
	 */
	loadCurrentCollectionAndCounters: function() {
	    
	    $M.toggleWait(true);
	    //Set filters
	    this.setCollectionsFilters();
	    //Call counter
	    this.refreshCounters();
	    //Fetch current collection
	    if (!this.currentCollection) {
	        this.currentCollection = this.$.overduecollection;
	    }
	    
	    if(this.currentCollection.timeLineAttribute && this.currentCollection.timeLineAttribute!='' && !this.currentCollection.timeLineAttribute.includes("=")){
        	this.currentCollection.timeLineAttribute = this.currentCollection.timeLineAttribute+'=&SYSDAY&';
        }
	    
	    var searchVal=this.currentCollection.searchTermValue;
		
	  	if(!searchVal.includes('\"')) {
	   		searchVal='\"'+searchVal+'\"';
	   		this.currentCollection.searchTermValue=searchVal;
	  	}
	  	
	    this.currentCollection.refreshRecords();
	},
	
	/**
	 * Set filters to all collections
	 */
	setCollectionsFilters: function() {
        this.filterAll();
        this.filterOverdue();
        this.filterToday();
        this.filterTomorrow();
        this.filterNextThreeDays();
        this.filterCompleted();
    },
	
	/**
	 * Fires all collection to fetch counters
	 */
	refreshCounters: function() {
		var self = this;
		
		//set &SYSDAY& as default if no date value is assigned for timeline attribute
		var collectionArray = [this.$.technicianWOCollection,this.$.overduecollection,this.$.todaycollection,this.$.tomorrowcollection,this.$.nextdayscollection,this.$.completedcollection];
		collectionArray.forEach(function(collection){
			if(collection.timeLineAttribute && collection.timeLineAttribute!='' && !collection.timeLineAttribute.includes("=")){
				collection.timeLineAttribute = collection.timeLineAttribute+'=&SYSDAY&';
	        }
		});
		
	    this.$.technicianWOCollection.getCollectionCount().then(function(){
	    	self._collectionCountFetched('technicianWOCollection');
	    });
	    this.$.overduecollection.getCollectionCount().then(function(){
	    	self._collectionCountFetched('overduecollection');
	    });
	    this.$.todaycollection.getCollectionCount().then(function(){
	    	self._collectionCountFetched('todaycollection');
	    });
	    this.$.tomorrowcollection.getCollectionCount().then(function(){
	    	self._collectionCountFetched('tomorrowcollection');
	    });
	    this.$.nextdayscollection.getCollectionCount().then(function(){
	    	self._collectionCountFetched('nextdayscollection');
	    });
	    this.$.completedcollection.getCollectionCount().then(function(){
	    	self._collectionCountFetched('completedcollection');
	    });
	},

	/**
	 * Called after collection counts are fetched.  Handle selecting tabs.
	 */
	_collectionCountFetched : function(id){
		if(this._collectionIDs!==undefined){
			delete this._collectionIDs[id];
			if (Object.keys(this._collectionIDs).length===0){
				var self = this;
				this._collectionIDs = undefined;
				var setSelector = function(index,tabName){
					var techWOList = self.getTechWOList();
					self._setTabCollection({'detail':tabName});
					techWOList.$.contentSelector.select(index);
					techWOList.$.contentSelector.defaultIndex=index;
					this.bypassFlag = true;
					$M.fire('workcenter-ready', true, this.bypassFlag); 
				};
				if(this.$.overduecollection.totalCount>0){
					return setSelector(0,'overdue');
				} 
				if(this.$.todaycollection.totalCount>0){
					return setSelector(1,'today');
				}
				if(this.$.tomorrowcollection.totalCount>0){
					return setSelector(2,'tomorrow');
				}
				if(this.$.nextdayscollection.totalCount>0){
					return setSelector(3,'nextdays');
				}
				if(this.$.technicianWOCollection.totalCount>0){
					return setSelector(5,'all');
				}
				if(this.$.completedcollection.totalCount>0){
					return setSelector(4,'completed');
				}	
			}
		}
	},
	
	/**
	 * Gets the collection count
	 */
	_getRecordCount : function(){
		return this.currentCollection.totalCount;
	},

	/**
	 * Update collection and counts when switching tabs
	 */
	_filtercollection: function(e){
		this._setTabCollection(e);
	},

	_setTabCollection: function(e){
		var newCollection; 
		//clear search when changing tabs
		this.clearSearch();
			
		if (e.detail==='overdue'){
			this.setTab('filterOverdue');
			newCollection = this.$.overduecollection;
		} else if(e.detail==='today'){
			this.setTab('filterToday');
			newCollection = this.$.todaycollection;
		} else if(e.detail==='tomorrow'){
			this.setTab('filterTomorrow');
			newCollection = this.$.tomorrowcollection;
		} else if(e.detail==='nextdays'){
			this.setTab('filterNextThreeDays');
			newCollection = this.$.nextdayscollection;
		} else if(e.detail==='completed'){
			this.setTab('filterCompleted');	
			newCollection = this.$.completedcollection;
		} else {
			//All tab was selected
			this.setTab('filterAll');
			newCollection = this.$.technicianWOCollection;
		}
        this.currentCollection = newCollection;

		if(!this.currentCollection.collectionData){
			this.currentCollection.refreshRecords();
		}
        
        if(this.currentCollection.timeLineAttribute && this.currentCollection.timeLineAttribute!='' && !this.currentCollection.timeLineAttribute.includes("=")){
        	this.currentCollection.timeLineAttribute = this.currentCollection.timeLineAttribute+'=&SYSDAY&';
        }
		
        this.getTechWOList().fire('load-next-list',this);
	},
	
	/**
	 * Clear search and reset filter / count when clicking filters
	 */
	clearSearch : function() {
		var searchBar = $j('#techWOList_searchbarOut');
		if(searchBar && searchBar.length > 0){
			var self = this;
			if(searchBar.find('maximo-searchbar')[0].$.inputval.value.length>0){
				searchBar.find('maximo-searchbar')[0].clear();
				if(searchBar.find('maximo-searchbar')[0].collection[0]){
					searchBar.find('maximo-searchbar')[0].collection[0].searchTermValue='';
					var tab = this.currentTab;
					searchBar.find('maximo-searchbar')[0].collection[0].refreshRecords().then(function(set){
						var count = set.response.member.length;
						self.updateCount(self,tab,count);
						self.refreshCounters();
					});
				}
			}
		}	
	},
	
	fetchIncompleteStatus: function() {
	    //maxval not in 'CAN','CLOSE','COMP'
	    var values = [];
	    if(this.woStatusSet && this.woStatusSet.length > 0){
		    for (let value of this.woStatusSet) {
		        if (value.maxvalue === 'CAN' 
	                || value.maxvalue === 'CLOSE'
	                    || value.maxvalue === 'COMP') {
		            continue;
		        }
		        values.push(value.value);
	        }
	    }
	    return values;
	},
	
	/**
	 * Display records with a schedstart date which is within 30 days from today.
	 */
	filterOverdue : function(showWait) {
		$M.toggleWait(true);
		
		var overduecollection = this.$.overduecollection;
		var today = '&SYSDAY&';
							
		var allowedStatus = this.fetchIncompleteStatus();
		var maxauth = $M.getMaxauth();
		
		maximoQbe = new MaximoQbe();
		maximoQbe.setEquals('siteid','-dfltsite-')
		    .setIn('status',allowedStatus)
		    .setLess('schedstart',today);
		var qbeObject = maximoQbe.toJSON();
		if(!overduecollection.queryWhere && overduecollection.queryWhere!=''){
			overduecollection.queryWhere = qbeObject;	
		}

		if(this.currentCollection){
			this.$.overduecollection.orderByAttributeNames  = this.currentCollection.orderByAttributeNames;
			
		    var searchVal=this.$.overduecollection.searchTermValue;
			
		  	if(!searchVal.includes('\"')) {
		   		searchVal='\"'+searchVal+'\"';
		   		this.$.overduecollection.searchTermValue=searchVal;
		  	}

			this.$.overduecollection.refreshRecords();
		}
		
		this.copyOverdueCollection = this.$.overduecollection;  // Added collection to retain and used it for changing the filter tab (Condition is available in attached function

	},
	
	/**
	 * Display records where the schedstart date is equal to todays date
	 */
	filterToday : function(e) {
		$M.toggleWait(true);
		
		var todaycollection =  this.$.todaycollection;
		var today = '&SYSDAY&';		
		
		var allowedStatus = this.fetchIncompleteStatus();
        var maxauth = $M.getMaxauth();
        
        maximoQbe = new MaximoQbe();
        maximoQbe.setEquals('siteid','-dfltsite-')
            .setIn('status',allowedStatus);
        var qbeObject = maximoQbe.toJSON();
        
        if(!todaycollection.timeLineAttribute && todaycollection.timeLineAttribute!=''){
        	todaycollection.timeLineAttribute = 'schedstart='+today;
        }
        if(!todaycollection.queryWhere && todaycollection.queryWhere!=''){
        	todaycollection.queryWhere = qbeObject;
        }
		
		if(this.currentCollection){
			this.$.todaycollection.orderByAttributeNames  = this.currentCollection.orderByAttributeNames;
			
		    var searchVal=this.$.todaycollection.searchTermValue;
			
		  	if(!searchVal.includes('\"')) {
		   		searchVal='\"'+searchVal+'\"';
		   		this.$.todaycollection.searchTermValue=searchVal;
		  	}
		  	
			this.$.todaycollection.refreshRecords();
		}
	},
	
	/**
	 * Display records where the schedstart date is equal to tomorrows date
	 */
	filterTomorrow : function(e) {
		$M.toggleWait(true);
		
		var tomorrowcollection = this.$.tomorrowcollection;
		var tomorrow = '&SYSDAY&+1D';
				
		var allowedStatus = this.fetchIncompleteStatus();
        var maxauth = $M.getMaxauth();
        
        maximoQbe = new MaximoQbe();
        maximoQbe.setEquals('siteid','-dfltsite-')
            .setIn('status',allowedStatus);
        var qbeObject = maximoQbe.toJSON();
        
        if(!tomorrowcollection.timeLineAttribute && tomorrowcollection.timeLineAttribute!=''){
        	tomorrowcollection.timeLineAttribute = 'schedstart='+tomorrow;
        }
        if(!tomorrowcollection.queryWhere && tomorrowcollection.queryWhere!=''){
        	tomorrowcollection.queryWhere = qbeObject;
        }
        
		if(this.currentCollection){
			this.$.tomorrowcollection.orderByAttributeNames  = this.currentCollection.orderByAttributeNames;
			
		    var searchVal=this.$.tomorrowcollection.searchTermValue;
			
		  	if(!searchVal.includes('\"')) {
		   		searchVal='\"'+searchVal+'\"';
		   		this.$.tomorrowcollection.searchTermValue=searchVal;
		  	}
		  	
			this.$.tomorrowcollection.refreshRecords();
		}
	},
	
	
	/**
	 * Display records where the status is completed
	 */
	filterCompleted : function(e) {
		$M.toggleWait(true);
		
		var completedcollection = this.$.completedcollection;
		
        var maxauth = $M.getMaxauth();
        
        maximoQbe = new MaximoQbe();
        maximoQbe.setEquals('siteid','-dfltsite-')
            .setEquals('historyflag','0')
        var qbeObject = maximoQbe.toJSON();
        
        if(!completedcollection.queryWhere && completedcollection.queryWhere!=''){
        	completedcollection.queryWhere = qbeObject;
        }

		if(this.currentCollection){
			this.$.completedcollection.orderByAttributeNames  = this.currentCollection.orderByAttributeNames;
			
		    var searchVal=this.$.completedcollection.searchTermValue;
			
		  	if(!searchVal.includes('\"')) {
		   		searchVal='\"'+searchVal+'\"';
		   		this.$.completedcollection.searchTermValue=searchVal;
		  	}
		  	
			this.$.completedcollection.refreshRecords();
		}
		
	},
	
	/**
     * Display records where the status is completed
     */
    filterAll : function(e) {
        $M.toggleWait(true);
        
        var wocollection = this.$.technicianWOCollection;
        
        var maxauth = $M.getMaxauth();
        
        maximoQbe = new MaximoQbe();
        maximoQbe.setEquals('siteid','-dfltsite-')
            .setEquals('historyflag','0')
        var qbeObject = maximoQbe.toJSON();

        if(!wocollection.queryWhere && wocollection.queryWhere!=''){
        	wocollection.queryWhere = qbeObject;	
        }
        
        if(this.currentCollection){
            this.$.technicianWOCollection.orderByAttributeNames  = this.currentCollection.orderByAttributeNames;
            
		    var searchVal=this.$.technicianWOCollection.searchTermValue;
			
		  	if(!searchVal.includes('\"')) {
		   		searchVal='\"'+searchVal+'\"';
		   		this.$.technicianWOCollection.searchTermValue=searchVal;
		  	}

            this.$.technicianWOCollection.refreshRecords();
        }
        
    },
	
	/**
	 * Display records where the schedstart date is between today and next two days.
	 */
	filterNextThreeDays : function(e) {
		$M.toggleWait(true);
		
		var nextdayscollection = this.$.nextdayscollection;
		var dayAfterTomorrow = '&SYSDAY&+2D';
		
		var allowedStatus = this.fetchIncompleteStatus();
        var maxauth = $M.getMaxauth();
        
        maximoQbe = new MaximoQbe();
        maximoQbe.setEquals('siteid','-dfltsite-')
            .setIn('status',allowedStatus);
        var qbeObject = maximoQbe.toJSON();
        
        if(!nextdayscollection.timeLineAttribute && nextdayscollection.timeLineAttribute!=''){
        	nextdayscollection.timeLineAttribute = 'schedstart='+dayAfterTomorrow;
        }
        
        if(!nextdayscollection.queryWhere && nextdayscollection.queryWhere!=''){
        	nextdayscollection.queryWhere = qbeObject;	
        }
		
		if(this.currentCollection){
			this.$.nextdayscollection.orderByAttributeNames  = this.currentCollection.orderByAttributeNames;
			
		    var searchVal=this.$.nextdayscollection.searchTermValue;
			
		  	if(!searchVal.includes('\"')) {
		   		searchVal='\"'+searchVal+'\"';
		   		this.$.nextdayscollection.searchTermValue=searchVal;
		  	}

			this.$.nextdayscollection.refreshRecords();
		}
	},
	
	/**
	 * Returns date based on number of days added to current date
	 * returns YYYY-MM-DD
	 */
	_getDateFromToday: function (/*int*/ days){
		
		if (!days) {
			days = 0;
		}
		
		var date = new Date();
		date.setDate(date.getDate() + (days));
		var day = date.getDate();
		day =  day<10 ? '0'+day : day;
		
		var month = date.getMonth()+1;
		month =  month<10 ? '0'+month : month;
  		
  		return date.getFullYear()+'-'+month+'-'+day;
	},
	
	/**
	 * Load the attachments for this work order, and then do the actual transition
	 */
	_loadAttachments: function(record){
		var recordHref = record.href;
		if(record.istask){
		var self = this;
			var techWODetail = self.getTechWODetail();
			var parentTaskId = record.taskid;
			techWODetail.getDoclinksWoactivityURL(record).then(function(record){
				var tempArray;
				if(record.response && record.response.member && record.response.member.length>0 && record.response.member[0].woactivity){
					tempArray = record.response.member[0].woactivity.filter(function(rec) {
						if(parentTaskId === rec.taskid){
							return rec.localref;
						}
					});
				}
				
				recordHref = (tempArray)?tempArray[0].localref:recordHref;
				self.refreshAttachmentCollection(recordHref);	
		});	
			
		}else{
			this.refreshAttachmentCollection(recordHref);
		}
		
	},
	
	/**
	 * Refresh that attachment collection locally so the new images displayed will be correct.
	 */
	_refreshAttachments: function(){
		var self = this;
		this.$.attachmentsCollection.refreshRecords().then(function(records){
			self.getTechWODetail()._attachments = records.response.doclinks.member;
		});
	},
	
	/**
	 * Set the selected content selector tab
	 */
	setTab : function(tab){
		this.currentTab = tab;
	},
	
	/**
	 * Get the current selected  tab
	 */
	getTab : function(){
		return this.currentTab;
	},
	/**
	 * Begin Assignment and change the workoder status to InProgress.
	 */
	_beginAssignment : function(e){
		var record = e.detail;
		this.$.technicianResource.resourceUri = record.href;
		var params = {} ;	
		var self = this;
		var responseProperties = 'status,wonum,worktype';	
		params={'status':self._getExternalValue('INPRG')};
		
		this.$.technicianResource.updateAction('wsmethod:changeWOStatus', params, responseProperties).then(function(x){
				var WorkOrder = x.__data__.response;
				self.getTechWODetail().record = WorkOrder;	
				self._refreshCurrentCompAll();
				self._handleMobileActionFooterNav();	
				self.getReportWork().$.completeButtons.hidden =false;
	    	});
	},
	
	_startAssignment : function(e) {	
		var record = e.detail.record;
		var transType = e.detail.workType;
		var laborcode = e.detail.laborcode;
		var labtransData = {'transtype':transType,'laborcode':laborcode};
		this.$.technicianResource.resourceUri = record.href;
		var params = {'labtrans.transtype': transType} ;
		var self = this;
		var responseProperties = this.attributeList + ',labtrans{*}';
		var techWODetail = this.getTechWODetail();
		
		this.$.technicianResource.updateAction('wsmethod:startTimer', params, responseProperties).then(function(x){
			var labTrans = x.__data__.response.labtrans;
			var WorkOrder = x.__data__.response;
			self.mbo = WorkOrder;
			var userInfo = $M.getUserInfo();
			if(!userInfo || !userInfo.labor){
				var technicianCard = this;
				this.async(function(){
					technicianCard._showStart();
				}, 200);
				return;
			}
			var userLaborCode = userInfo.labor.laborcode;	
			var activeLabtrans = '';
			if(labTrans){
				if(labTrans.length>0){
					labTrans.forEach(function(member){
						if(member.laborcode===userLaborCode){
							if(member.timerstatus_maxvalue==='ACTIVE'){
								activeLabtrans = labTrans[labTrans.length-1];
							}
						}
					});
				}
				else{
					activeLabtrans = labTrans;
				}
			}
				
			self.$.labtransResource.resourceUri = activeLabtrans.localref;
			labtransData.labtransid = activeLabtrans.labtransid;
					var responseProperties = 'labtrans{*}';
					self.$.labtransResource.updateRecord(labtransData, responseProperties, true).then(function(result) {
						$M.toggleWait(false);
					});
										
			self.currentCollection.refreshRecords();
			var showStart = techWODetail._showStart(WorkOrder); 
			var showStop = techWODetail._showStop(WorkOrder);
			
			techWODetail.$.worklinks1.hidden = showStart;
			techWODetail.$.worklinks2.hidden = showStop;
			if(self.currentPage === 'techWOList'){
				techWODetail.disableActions = true;
			}
			self._handleMobileActionFooterNav();
		}.bind(this), function(error){
			$M.showResponseError(error);
			self.currentCollection.refreshRecords();
			var showStart = techWODetail._showStart(record); 
			var showStop = techWODetail._showStop(record);
			
			techWODetail.$.worklinks1.hidden = showStart;
			techWODetail.$.worklinks2.hidden = showStop;
			self._handleMobileActionFooterNav();
		});
	},
	
	
	/**
	 * Complete Work order from Report Actuals
	 * Reset historyStack and return user to Technician List
	 */
	_goBackAndCompleteWO : function(e){
		var self = this;
		var record =  this.mbo;
		var wonum= record.wonum;
		var worktype= record.worktype;
		
		//disable Complete Work Button to prevent multiple clicks
		$M.findElementParent(e.detail,'MAXIMO-BUTTON').disabled = true; 
		
		//Clear undefined string
		worktype = (worktype) ? worktype : '';
		
		var message = $M.localize('uitext','mxapiwodetail','woStatusComplete',[worktype,wonum]);
		this.disableBack = false;
		var performChangeStatus = function(overlayNode) {
			self._completeWO(e,self.mbo);
			setTimeout(function(){ 
				self._loadButtons();
		 	 	}, 200);
			
			if(!self.disableBack){
				self.historyStack = [];
				self.fire('goback');	
			} else {
				this.disableBack = false;
			}
		};
		
		var undo = function() {
			$M.findElementParent(e.detail,'MAXIMO-BUTTON').disabled = false;
		};
			
		$M.notify(message, $M.alerts.info, performChangeStatus,undo);
	},
	
	_completeWO : function(e, record) {	
		var self = this;
		var contentProps = {
			'cancelCallback': function (){
             	self._toggleCompleteButton(e.detail, false);
             }
		};
		if(record.worktypeprompt === true && (record.failure && (record.problemcode === undefined || record.problemcode === ''))){
			var typeTitle = $M.localize('uitext', 'mxapiwodetail', 'failurewarning');
   			$M.confirm(typeTitle, function(response, event){
   				if(response === false){
   					return this._completeWOStatus(e);
   				} else {
   					self._toggleCompleteButton(e.detail, false);
   				}
   			}, this, 3, [2,3], null, $M.alerts.warn, true, contentProps);
   		} else {
   			return this._completeWOStatus(e);
   		}
	},
	
	_completeWOStatus : function(e){
		var self = this;
		return new Promise(function(resolve,reject){
			var params = {status: self._getExternalValue('COMP')};	
			
			var responseProperties = 'status,wonum,worktype,problemcode,failure.description,problem.description,failurecode,remarkdesc';	
			
					
			//if technicianResource.resourceURI is not set, set url from record.
			if(!self.$.technicianResource.resourceUri){
				self.$.technicianResource.resourceUri = self.mbo.href;
			}
			
			self.$.technicianResource.updateAction('wsmethod:changeWOStatus', params, responseProperties).then(function(x){
					var WorkOrder = x.__data__.response;
					self.mbo = WorkOrder;
					self._refreshCurrentCompAll();
					
					//enable Complete Work Button
					if(e.detail && e.detail.parentElement && e.detail.parentElement.id==='completeWork'){
						e.detail.parentElement.disabled = false;
					}
					
					trackAnalyticsPerformedAction('work order', 'Complete work order', 'Complete work order');
					resolve({'detail':WorkOrder});
			}.bind(this), function(error){
				$M.showResponseError(error);
				var reportwork = self.getReportWork();
				if(reportwork){
					reportwork.$.completeButtons.hidden=false;
				}
			});
		});
	},
	
	/**
	 * Complete Assignment after Stop
	 */
	_finishAssignment : function(e) {	
		var record = e.detail.wonum ? e.detail : this.mbo;
		this.$.technicianResource.resourceUri = record.href;
		var params = {} ;	
		var self = this;
		var responseProperties = 'status';	
		var wonum= record.wonum;
		var worktype= record.worktype;
		var wostatus = record.status_maxvalue;
		var message = $M.localize('uitext','mxapiwodetail','woStatusComplete',[(worktype && !record.istask?worktype:'') ,wonum]);
			self._toggleCompleteButton(e.detail, true);
	    	var performChangeStatus = function(overlayNode) {
	    		if(wostatus !== 'COMP'){
	    		self._completeWO(e,record).then(function(rec){
	    			wostatus = rec.detail.status_maxvalue;
	    			rec.detail.ltTypeSet = record.ltTypeSet;
	    			self.currentCollection.refreshRecords();
	    			self._reportWork(rec);
	    		});
	    		}
			};
			
			var doStopTimeAndChangeStatus = function() {
				if(record && self.$.techWODetail && !self.$.techWODetail._showStop()){
					var whoami = $M.getMaxauth().whoami;             
					var dateTimeFormat = whoami.datetimeformat.replace(whoami.dateformat,whoami.dateformat.toUpperCase());
					params.finishdatetime = moment(record.schedstart || record.actstart,'YYYY-MM-DD HH:mm:ss').format(dateTimeFormat);
					self.$.technicianResource.updateAction('wsmethod:stopTimer', params, responseProperties).then(function(x){
						performChangeStatus();
						self._handleMobileActionFooterNav();
					});
				} else {
					performChangeStatus();
				}
			};
			
		    var undo = function() {
		    	if (e.target.id !=='technicianmain_techReportWork'){		    		
		    		self._toggleCompleteButton(e.detail, false);
		    	}
		    };
		    $M.notify(message, $M.alerts.info, doStopTimeAndChangeStatus, undo);
		
	},

	/**
	 * Stop Assignment only
	 */
	_stopAssignment : function(e) {	
		var record = e.detail;
		this.$.technicianResource.resourceUri = record.href;

		var stopDateTime = e.target.__data__.stopDate+' '+e.target.__data__.stopTime;
		var startDateTime = e.target.__data__.startDate+' '+e.target.__data__.startTime;
		
		var whoami = $M.getMaxauth().whoami;	
		var dateTimeFormat = whoami.datetimeformat.replace(whoami.dateformat,whoami.dateformat.toUpperCase());

		if($M.isMobile()){
			stopDateTime = moment(stopDateTime,'YYYY-MM-DD HH:mm:ss').format(dateTimeFormat);
			startDateTime = moment(startDateTime,'YYYY-MM-DD HH:mm:ss').format(dateTimeFormat);
		} 
		
		var params = {'finishDateTime' : stopDateTime, 'startDateTime':startDateTime, 'noStopTimerPopup': true} ;	
		var self = this;
		var responseProperties =  this.attributeList + ',labtrans{*}';
		var techWODetail =self.getTechWODetail();
		this.$.technicianResource.updateAction('wsmethod:stopTimerStartFinishDates', params, responseProperties).then(function(x){			
			$M.toggleWait(false);
			self.currentCollection.refreshRecords();
			var workOrder = x.__data__.response;
			var showStart = techWODetail._showStart(workOrder); 
			var showStop = techWODetail._showStop(workOrder);
			
			techWODetail.$.worklinks1.hidden = showStart;
			techWODetail.$.worklinks2.hidden = showStop;
			self._handleMobileActionFooterNav();
		}.bind(this), function(error){
			$M.showResponseError(error);
			$M.toggleWait(false);
			self.currentCollection.refreshRecords();
			techWODetail.$.worklinks1.hidden = true;
            techWODetail.$.worklinks2.hidden = false;
			self._handleMobileActionFooterNav();
		});
	},
	/**
	 * format the date for stopping the 
	 * assignment. 
	 */
	_formatDateToStopAssignment: function(){
		if ($M.getMaxauth().whoami && $M.getMaxauth().whoami.dateformat && $M.getMaxauth().whoami.timeformat && $M.getMaxauth().whoami.datetimeformat){
			this.dateFormat = $M.getMaxauth().whoami.dateformat.toUpperCase();	  			
			this.dateTimeFormat = $M.getMaxauth().whoami.datetimeformat.replace($M.getMaxauth().whoami.dateformat,$M.getMaxauth().whoami.dateformat.toUpperCase());
			this.timeFormat =  $M.getMaxauth().whoami.timeformat;
			this.showAMPM = $M.getMaxauth().whoami.datetimeformat.includes('a');
		} else {
			this.dateFormat = 'MM/DD/YYYY';
			this.dateTimeFormat = 'MM/DD/YYYY hh:mm';
			this.timeFormat = 'hh:mm';
			this.showAMPM = true;
		}
	},
	
	
	/**
	 * Refreshes current collection as well as Complete and All Collections
	 * Sets counts for current / complete / All 
	 */
	_refreshCurrentCompAll : function(e){
		var self = this;
		this.currentCollection.refreshRecords().then(function(){
			var count = self.currentCollection.totalCount;
			var tab = self.currentTab;
			self.updateCount(self,tab,count);		
			self.$.completedcollection.refreshRecords().then(function(){
				var  techWOList = self.getTechWOList();
				techWOList.completedCount = self.$.completedcollection.totalCount;
				self.$.technicianWOCollection.refreshRecords().then(function(){
					techWOList.allRecordCount = self.$.technicianWOCollection.totalCount;
					techWOList.$.technicianList.fire('iron-resize');
				});
			});
		});
	},	
	
	/**
	 * reload the attachments for this work order
	 */
	_reloadAttachments:function(event){
		this._loadAttachments(event.detail.record);
	},
	/**
	 * update Footer action button for mobile view.
	 */
	_updateFooter: function(event){
		var self=this;
		setTimeout(function(){ 
		  self._handleMobileActionFooterNav();
 	 	}, 200);
	},
	
	/**
	 * Fetch/clear buttons and set on footer. 
	 */
	_loadButtons: function(tab){
		var buttons = null;
		var context = this;
		var techWODetail = this.getTechWODetail();
		var techWOList = this.getTechWOList();
		var techReportWork = this.getReportWork();
		switch(tab){
			case 'details':
				var currStatus;
                if (techWOList.record){
                     currStatus=techWOList.record.status_maxvalue;
                }
                if(!currStatus && techWODetail.record){
                	currStatus = techWODetail.record.status_maxvalue;	
                }
                if((currStatus && currStatus==='WAPPR' || currStatus==='CLOSE') && !techWODetail.createWO){
                    buttons = null;
                }else{
					var height = $j(techWODetail.$.divBar).height();
            		if($M.isMobile() || height > 50){
        	  			if(!techWODetail.disableActions){
        	  				buttons = this._getFooterDetailButtons();
        	  			}
        	  		}else{
        	  			buttons = null;
        	  		} 
                }
                if(techWODetail.record && techWODetail.record.status_maxvalue === 'COMP'){
                	techWODetail.$.worklinks1.hidden = true;
                	techWODetail.$.worklinks2.hidden = true;
                }
				break;
			case 'reportwork':
				if(techReportWork.record.status_maxvalue==='COMP'){
					techReportWork.$.completeButtons.hidden = true;
					buttons = null;
				} else {
					if($j(techReportWork.$.mainPage).width()>500){
					techReportWork.$.completeButtons.hidden = false;
                    } else {
                	    techReportWork.$.completeButtons.hidden =true;
                        buttons = this._getFooterReportWorkButtons();
                    }
				}
				break;
			case undefined:
				buttons = null;
				break;
			default:
				buttons = null;
				break;
		}
		
		$M.workScape.updateFooterToolbar(buttons, context);
				
	},
	
	/**
	 * Detail buttons
	 */
	_getFooterDetailButtons : function(e){
	   	 //Detail page Action buttons
	   	 
		var techWODetail = this.getTechWODetail();
		if(techWODetail.createWO){
			var buttons = [{'id':'cancelButtonWorkorder','action':true,'label':this.localize('uitext','mxapibase','Cancel'),'event':'cancel-work-order'},
						   {'id':'saveButtonWorkorder','action':false,'label':this.localize('uitext','mxapibase','save'),'event':'save-work-order'}];
		}else{
			var buttons = [ {'id':'reportAct','action':'true','label':this.localize('uitext','mxapiwodetail','reportWork'),'event':'reportWorkFooter','icon':'Maximo:Arrow2-Forward','context':$j('maximo-technician-detail')[0]}];			
		}
		var startStop = $j('.startStopRWButtons');
		var startHidden = startStop.find('div[data-scope-id=worklinks1]').attr('hidden');
		var stopHidden = startStop.find('div[data-scope-id=worklinks2]').attr('hidden');
		if(startHidden !== 'hidden'){
			buttons.push({'id':'footerStart','label':this.localize('uitext', 'mxapiwodetail', 'start'),'event':'startFromFooter','context':$j('maximo-technician-detail')[0]});
		}
		else if(stopHidden !== 'hidden'){
			buttons.push({'id':'reportAct','label':this.localize('uitext','mxapiwodetail','stop'),'event':'stopFromFooter','context':$j('maximo-technician-detail')[0]});
		}
			
		return buttons;
	 },
	 
	/**
	 * Report Work buttons (Complete work order)
	 */
	_getFooterReportWorkButtons : function(e){
	   	 //Report Work page Action buttons
		return [{'id':'completeWork','action':true,'label':this.localize('uitext','mxapiwodetail','Completework'),'event':'finishAssignment','icon':'Maximo:Confirm'}];
	 },
		 
	/**
	 * Hides/Shows Actions on Header/Footer depending on device size.
	 */
	_handleMobileActionFooterNav : function(){
		var  techWODetail = this.getTechWODetail();
		techWODetail.toggleHeaderActionsVisibility =  false;
		$j(techWODetail.$.workorderSaveCancel).css('display','flex'); 
		var height = $j(techWODetail.$.divBar).height();
		if($M.isMobile()){
	  		if(!techWODetail.disableActions){
	  			if(this.currentPage==='techReportWork'){
	  		  		this._loadButtons('reportwork');
	  		  	} else{
	  		  		this._loadButtons('details');//show footerbar
	  		  	}
	  		}
	  		techWODetail.toggleHeaderActionsVisibility =  true; //hide actions on header
	  		$j(techWODetail.$.workorderSaveCancel).css('display','none');
	  		return;
	  	}
	  	else {
	  		this._loadButtons();
	  	}
		techWODetail.toggleHeaderActionsVisibility = false;
	},
	
	/**
	 * Page navigation management
	 * Load buttons depending on page.
	 */
	_changePage: function (pageName, isGoingBack) {		
	 	this.addContent(pageName);
		var self = this;
		if (this.currentPage !== pageName) {
			
			if (!isGoingBack || isGoingBack !== true) {
				this.historyStack.push(this.currentPage);
			}
			this.currentPage = pageName;
			document.scrollingElement.scrollTop = 0;
			
			if(pageName==='techReportWork'){
				setTimeout(function(){ 
					self._loadButtons('reportwork');
					if(self.$.techReportWork){
						self.$.techReportWork.loadReportedWorkFailureRecord();
					}
				}, 200);
				$M.workScape.backTopHide = false;
			} else if (pageName==='techWODetail') {				
				self.getTechWODetail().disableActions=false;
				self._loadButtons('details');
				setTimeout(function(){ 
					self._handleMobileActionFooterNav();
	 	 		}, 200);
				$M.workScape.backTopHide = false;
			} else if (pageName==='techWOList') 
			{
				self.getTechWODetail().disableActions=true;
				this._loadButtons();
				self.getTechWOList().$.technicianList.fire('iron-resize');
				$M.workScape.backTopHide = true;
				$M.workScape.querySelector('.backTop').classList.remove('show');
			} else {
				this._loadButtons();
			}

			this.$.pages.select(pageName);
			
			//push ui to redraw
			if (pageName==='techWOList'){
				setTimeout(function(){ 
					self.getTechWOList().$.technicianList.fire('iron-resize');
					var woListContentSelector = $j(self.$.pages).find('maximo-content-selector').first()[0];
					woListContentSelector._fixArrows();
	 	 		}, 200);
			}
			
			return;
		}
	},
	
	/**
	 * Set Work Type domain list data
	 */
	_domaincollection : function(){
		this.getTechWOList().ltTypeSet = this.ltTypeDomainCollection[0];
	},	 
    /**
	 * Parse domains to create key:description string array for Drop Down
	 */
	_domainList : function(e){
		var self = this;
		this.ltTypeValues='';
		var worktypes = e.detail;
		var externalValues=[];
			if(worktypes.length>0){
				worktypes.forEach(function(member){
					if(member.maxvalue==='WORK'){
						externalValues.push(member.value+':'+self.fixDescription(member.value,member.description));
					}
				});
		
		}
		e.detail.selectedValues=externalValues.toString();
	},
	/**
	 * Trigger via listener to update counts on current, comp and all.
	 */
	_statusChanged : function(e){
		this._refreshCurrentCompAll(e);
	},
	/*  
	 * Show asset details admin page
	 */
    _showAssetDetail: function(e){	
    	if(!this.isAuthorized('MXAPIASSET:READ')){
    		console.log('access denied for Asset Details' );
			return; 
		}
    	if(this.getTechWODetail()){
    		this.getTechWODetail().disableActions=true;
    	}
    	this._handleMobileActionFooterNav();
    	this.addContent('showAssetDetail');
		var currentRecord = '';				
		if(e.detail.record){
			currentRecord = e.detail.record;
		} else {
			currentRecord = e.detail;
		}		
		this.assetData = currentRecord;
		var showAssetDetail = this.getAssetDetail();
		showAssetDetail.set('assetDescription', currentRecord.description);			
		showAssetDetail._refreshRecord();
		this._changePage('showAssetDetail');		
	},
	/*  
	 * Show location details page
	 */
	_showLocationDetails: function(e){
		if(!this.isAuthorized('MXAPIOPERLOC:READ')){
			console.log('access denied for Location Details' );
			return; 
		}
		if(this.getTechWODetail()){
    		this.getTechWODetail().disableActions=true;
    	}
    	this._handleMobileActionFooterNav();
		this.addContent('locationDetails');
		var currentRecord = '';				
		if(e.detail.record){
			currentRecord = e.detail.record;
		} else {
			currentRecord = e.detail;
		}
		var locationDetails = this.getLocationDetail();
		
		locationDetails.parentLocation = '';
		locationDetails.parentDescription = '';
		locationDetails.parentImage = '';
		locationDetails.set('record',currentRecord);
		if(currentRecord.lochierarchy){
			locationDetails._populateSystem(currentRecord); 
		}
		locationDetails.locationsite = currentRecord.siteid;
		if(currentRecord.parent && currentRecord.parent !== 'SYSTEMLOC') {				
			locationDetails.parentLocation = currentRecord.parent;
			locationDetails.parentDescription = currentRecord.location_parent.description;
			locationDetails.parentImage = currentRecord.location_parent._imagelibref;							
		}	
		locationDetails._refreshChildrenTile();
		locationDetails._refreshAssetTile();
				
		this._changePage('locationDetails');
		$j(locationDetails).closest('div.absolutePage').css('height', 'auto');
	},
	
	/*  
	 * Used to display the goBack page for common detail component 
	 */
	_goBackPage : function(e){
		 if(e.target.is==='maximo-location-detail' || e.target.is==='maximo-asset-detail'){
			 this._changePage('techWODetail');
			 this.pageName='techWOList';
			 var detailsPage = this.getTechWODetail();
			 if(detailsPage.actionScrollTop){
				 window.scrollTo(0, detailsPage.actionScrollTop);
			 }
			 if(e.target.is==='maximo-location-detail'){
				 detailsPage.$.locationimg.image = e.target.record._imagelibref;
			 }else{
				 detailsPage.$.assetimg.image = e.target.record._imagelibref;
			 }
		 }
		
	},
	
	/************** MX Collection and Resource Handlers BEGIN ****************/
	
	/**
     * technicianWOCollection mx-collection refreshRecord success handler
     */
    _woListRefreshSuccessHandler: function() {
    	this.updateCount(this,"filterAll",this.$.technicianWOCollection.totalCount);
        this.updateDataSet();
        $M.toggleWait(false);
    },

    /**
     * technicianWOCollection mx-collection refreshRecord error handler
     */
    _woListRefreshErrorHandler: function(event) {
        var error = event.detail;
        console.error(error);
        $M.toggleWait(false);
    },

    /**
     * overduecollection mx-collection refreshRecord success handler
     */
    _overdueListRefreshSuccessHandler: function() {
    	this.updateCount(this,"filterOverdue",this.$.overduecollection.totalCount);
        this.updateDataSet();
        $M.toggleWait(false);
    },

    /**
     * overduecollection mx-collection refreshRecord error handler
     */
    _overdueListRefreshErrorHandler: function(event) {
        var error = event.detail;
        console.error(error);
        $M.toggleWait(false);
    },
    
    /**
     * todaycollection mx-collection refreshRecord success handler
     */
    _todayListRefreshSuccessHandler: function() {
    	this.updateCount(this,"filterToday",this.$.todaycollection.totalCount);
        this.updateDataSet();
        $M.toggleWait(false);
    },

    /**
     * todaycollection mx-collection refreshRecord error handler
     */
    _todayListRefreshErrorHandler: function(event) {
        var error = event.detail;
        console.error(error);
        $M.toggleWait(false);
    },
    
    /**
     * tomorrowcollection mx-collection refreshRecord success handler
     */
    _tomorrowListRefreshSuccessHandler: function() {
    	this.updateCount(this,"filterTomorrow",this.$.tomorrowcollection.totalCount);
        this.updateDataSet();
        $M.toggleWait(false);
    },

    /**
     * tomorrowcollection mx-collection refreshRecord error handler
     */
    _tomorrowListRefreshErrorHandler: function(event) {
        var error = event.detail;
        console.error(error);
        $M.toggleWait(false);
    },
    
    /**
     * nextdayscollection mx-collection refreshRecord success handler
     */
    _nextDaysListRefreshSuccessHandler: function() {
    	this.updateCount(this,"filterNextThreeDays",this.$.nextdayscollection.totalCount);
        this.updateDataSet();
        $M.toggleWait(false);
    },

    /**
     * nextdayscollection mx-collection refreshRecord error handler
     */
    _nextDaysListRefreshErrorHandler: function(event) {
        var error = event.detail;
        console.error(error);
        $M.toggleWait(false);
    },

    /**
     * completedcollection mx-collection refreshRecord success handler
     */
    _completeListRefreshSuccessHandler: function() {
    	this.updateCount(this,"filterCompleted",this.$.completedcollection.totalCount);
        this.updateDataSet();
        $M.toggleWait(false);
    },

    /**
     * completedcollection mx-collection refreshRecord error handler
     */
    _completeListRefreshErrorHandler: function(event) {
        var error = event.detail;
        console.error(error);
        $M.toggleWait(false);
    },
    
    /**
     * Collection error
     */
    _handleError: function (e) {
        var error = e.detail.Error;
        $M.notify(error.message, $M.alerts.error);
        
        this.getTechWOList().dataSetRefresh();
        $M.toggleWait(false);
    },
    
    /**
     * Enable wait layer, initiated on refresh of collection
     */
    _loading : function(e){
        $M.toggleWait(true);
        
        //To load spinner making count as -1 , this means collections is being refreshed
        if(e.currentTarget.id === 'overduecollection'){
           this.getTechWOList().overdueCount =-1;
        }
        if(e.currentTarget.id === 'todaycollection'){
            this.getTechWOList().todayCount =-1;
        }
        if(e.currentTarget.id === 'tomorrowcollection'){
            this.getTechWOList().tomorrowCount =-1;
        }
        if(e.currentTarget.id === 'nextdayscollection'){
            this.getTechWOList().nextdaysCount =-1;
        }
        if(e.currentTarget.id === 'completedcollection'){
            this.getTechWOList().completedCount =-1;
        }
        if(e.currentTarget.id === 'technicianWOCollection'){
            this.getTechWOList().allRecordCount =-1;
        }
    },
    
    /**
     *  technicianWOCollection mx-collection getCollectionCount success response
     */
    _countListSuccessHandler: function(event) {
    	this.getTechWOList().allRecordCount = event.detail;
    },
    
    /**
     * overduecollection mx-collection getCollectionCount success response
     */
    _countOverdueSuccessHandler: function(event) {
    	this.getTechWOList().overdueCount = event.detail;
    },
    
    /**
     * todaycollection mx-collection getCollectionCount success response
     */
    _countTodaySuccessHandler: function(event) {
    	this.getTechWOList().todayCount = event.detail;
    },
    
    /**
     * tomorrowcollection mx-collection getCollectionCount success response
     */
    _countTomorrowSuccessHandler: function(event) {
    	this.getTechWOList().tomorrowCount = event.detail;
    },
    
    /**
     * nextdayscollection mx-collection getCollectionCount success response
     */
    _countNextDaysSuccessHandler: function(event) {
    	this.getTechWOList().nextdaysCount = event.detail;
    },
    
    /**
     * completedcollection mx-collection getCollectionCount success response
     */
    _countCompletedSuccessHandler: function(event) {
    	this.getTechWOList().completedCount = event.detail;
    },
    
	/**
	 * woStatusDomain mx-collection refreshRecord success handler
	 */
	_woStatusDomainSuccessHandler: function() {
        var domainSet =[];
        if(this.readAceessGranted){
        	domainSet =this.$.woStatusDomain.collectionData;
        }
         //Fetch first item in array & fire collections
        if (domainSet && domainSet.length) {
            domainSet = domainSet[0];
            this.woStatusSet = domainSet.synonymdomain;
            this.loadCurrentCollectionAndCounters();
            //this.loadCollections();
        }else{
            // Disable the header when there is no read permissions for MXAPIWODETAIL
        	$j('.pageHeader').css({'position':'relative','top':'0px','z-index':'10'});
	    	$j('.pageHeader').append("<div style='position:absolute;left:0px;right:0px;bottom:0px;top:0px;z-index:11;'></div>"); 
            this.getTechWOList().overdueCount =0;
            this.getTechWOList().tomorrowCount =0;
            this.getTechWOList().todayCount =0;
            this.getTechWOList().nextdaysCount =0;
            this.getTechWOList().completedCount =0;
            this.getTechWOList().allRecordCount =0;
            this.async(function(){
                   $M.toggleWait(false);
            },50);
            return;
        }
     },

	
	/**
     * woStatusDomain mx-collection refreshRecord error handler
     */
	_woStatusDomainErrorHandler: function(e) {
        this.woStatusSet = [];
        console.error(e.detail);
    },
    
    /**
     * lttypedomain mx-collection refreshRecord success handler
     */
    _handleltTypeDomainSet : function(e){
    	if(this.ltTypeDomainCollection && this.ltTypeDomainCollection[0]){
    		this.ltTypeSet = this.ltTypeDomainCollection[0].synonymdomain;	
    	}
    },
    
    /**
     * lttypedomain mx-collection refreshRecord error handler
     */
    _handleltTypeDomainSetError : function(e){
        this.ltTypeSet = [];            
    },
    
    /************** MX Collection and Resource Handlers END ****************/

    /**
     * DEPRECATED
     * 
     * When collection gets refreshed, wait layer is disabled and triggers datassetrefresh on list
     */
    _handleRecordDataRefreshed: function (objs) {
    	this.getTechWOList().dataSetRefresh();
		this.displayedCollection = this.currentCollection.__data__.collectionData;
        
        var count = this._getRecordCount();
        this.updateCount(this,this.currentTab,count);
   
        $M.toggleWait(false);   
    },
    
    /**
     * DEPRECATED
     * 
     * Update Technician List Content Selector counts.
     */
    updateCount : function(self,tab,count){
        var techWOList = self.getTechWOList();
        switch(tab) {
            case 'filterToday':
                techWOList.todayCount = count;
                break;
            case 'filterOverdue':
                techWOList.overdueCount = count;
                break;
            case 'filterTomorrow':
                techWOList.tomorrowCount = count;
                break;  
            case 'filterNextThreeDays':
                techWOList.nextdaysCount = count;
                break;  
            case 'filterCompleted':
                techWOList.completedCount = count;
                break;      
            case 'filterAll':    
                techWOList.allRecordCount = count;
                break;
        }   
    },
    
    /**
     * DEPRECATED
     * 
     * Loads collections and sets filter counts
     */
    loadCollections: function() {
        var self = this;
		var techWOList = this.getTechWOList();
        this.filterNextThreeDays().then(function(){
           techWOList.nextdaysCount = self._getRecordCount();
            self.filterTomorrow().then(function(){
               techWOList.tomorrowCount = self._getRecordCount();
                self.filterOverdue().then(function(){
                   techWOList.overdueCount = self._getRecordCount();
                    self.filterAll().then(function(){
                       techWOList.allRecordCount = self._getRecordCount();
                        self.filterCompleted().then(function(){
                           techWOList.completedCount = self._getRecordCount();
                            self.filterToday().then(function(){
                               techWOList.todayCount = self._getRecordCount();
                                if(self.$.techWOList.overdueCount=='0'){
                                    self.setTab('filterToday');
                                   techWOList.$.contentSelector.select(1);
                                    $M.toggleWait(false);
                                }else {
                                    self.setTab('filterOverdue');
                                    self.currentCollection = self.copyOverdueCollection;
                                   techWOList.$.contentSelector.select(0);
                                    $M.toggleWait(false);
                                }
                            }); 
                        });
                    }); 
                });
            });
        });
    },
    
     /**  
     * 
     * add selected page on dom when the page is changed
     */
    _switchPage: function(){
    	this.addContent(this.selectedPage);
    },
    
    /**  
     * 
     * return  maximo-technician-list component
     * 
     */
    getTechWOList: function(){
    	var  techWOList = $j(this).find('maximo-technician-list')[0];
    	if(techWOList) {
    		return techWOList;
    	}
    	
    	this.addContent('techWOList');
    	
    	return  $j(this).find('maximo-technician-list')[0];
    },
    
    /**  
     * 
     * return  maximo-technician-detail component
     * 
     */
    getTechWODetail: function(){
    	var  techWODetail = $j(this).find('maximo-technician-detail')[0];
    
    	if(techWODetail) {
    		return techWODetail;
    	}
    	
    	this.addContent('techWODetail');
    	
    	return  $j(this).find('maximo-technician-detail')[0];
    },
    
    /**  
     * 
     * return maximo-technician-reportwork component
     * 
     */
    getReportWork: function(){
    	var  techReportWork = $j(this).find('maximo-technician-reportwork')[0];
        
    	if(techReportWork) {
    		return techReportWork;
    	}
    	
    	this.addContent('techReportWork');
    	
    	return  $j(this).find('maximo-technician-reportwork')[0];
    },
    
    /**  
     * 
     * return  maximo-asset-detail component
     * 
     */
    getAssetDetail: function(){
    	var  showAssetDetail = $j(this).find('maximo-asset-detail')[0];
        
    	if(showAssetDetail) {
    		return showAssetDetail;
    	}
    	
    	this.addContent('showAssetDetail');
    	
    	return  $j(this).find('maximo-asset-detail')[0];
    },
    
    /**  
     * 
     * return  maximo-location-detail component
     * 
     */
    getLocationDetail: function(){
    	var  locationDetails =  $j(this).find('maximo-location-detail')[0];
        
    	if(locationDetails) {
    		locationDetails.readOnly=true;
    		return locationDetails;
    	}
    	
    	this.addContent('locationDetails');
    	
    	locationDetails =  $j(this).find('maximo-location-detail')[0];
    	locationDetails.readOnly=true;
    	
    	return  locationDetails;
    	
    },
    
    /**
     * Fire event for report failure page.
     * Scroll to the ends if selection is last element, in general it hides the selected tab in mobile devices.
     */
    _failureDetails : function(e){
    	this.mbo = e.detail;
		this.addContent('techReportWork');
		this.getReportWork().cameFromCard = false;
		this.getReportWork().loadReportedWorkFailureRecord();
	    this._changePage('techReportWork');
  		var techreportwork = $j(this).find('maximo-technician-reportwork')[0];
  		if(techreportwork){
  		   var failureindex= $j(techreportwork.$.failures).index();
  		   techreportwork.$.technicianReportWorkSelector.select(failureindex);
           $j(techreportwork.$.section_failures).show();
           $j(techreportwork.$.section_time).hide();
           $j(techreportwork.$.section_items).hide();
           $j(techreportwork.$.section_tools).hide();
           $j(techreportwork.$.failures).trigger('click');
  		
  			var techfailure = techreportwork.$.maximo_failure_detail;
  			if(e.detail && e.detail.problemcode && e.detail.problem && e.detail.problem.description){
  				techfailure.$.collapseIconProblemWarning.hidden = true;
  	  			techfailure.$.collapseIconProblemConfirm.hidden = false;
  	  			$j(techfailure.$.cause).find('*').prop('disabled', false);
  	  			techfailure.$.collapseIconProblemWarning.classList.remove('blueIcon');
  	  			techfailure.$.collapseIconCauseDebug.classList.add('blueIcon');
  			}else {
  				techfailure.$.collapseIconProblemWarning.hidden = false;
  	  			techfailure.$.collapseIconProblemConfirm.hidden = true;
  	  			$j(techfailure.$.cause).find('*').prop('disabled', true);
  	  			$j(techfailure.$.remedy).find('*').prop('disabled', true);
  	  			techfailure.$.collapseIconProblemWarning.classList.add('blueIcon');
  	  			techfailure.$.collapseIconCauseDebug.classList.remove('blueIcon');
  	  			techfailure.$.collapseIconRemedyRecommendation.classList.remove('blueIcon');
  			}
  		 } 
  		this.fixHiddenContentOnMobile(techreportwork.$.technicianReportWorkSelector,150);
	  },
	/**
     * Fire event to the technician-card in order for it to receive all collections
     */
	_getCardCollections : function(e){
		e.detail.fire('designer-set-collections',[this.$.technicianWOCollection,this.$.overduecollection,this.$.todaycollection,this.$.tomorrowcollection,this.$.nextdayscollection,this.$.completedcollection]);
	}, 
	
	/**
	 * failTypeDomain mx-collection refreshRecord success handler
	 */
	_failTypeDomainSuccessHandler: function() {
		$M.toggleWait(true);
		var domainSet = this.$.failTypeDomain.collectionData;
	    //Fetch first item in array & fire collections
	    if (domainSet && domainSet.length) {
	        domainSet = domainSet[0];
	        this.failTypeSet = domainSet.synonymdomain;
	    }
	},
	
	/**
     * failTypeDomain mx-collection refreshRecord error handler
     */
	_failTypeDomainErrorHandler: function(e) {
        this.failTypeSet = [];
    },
	  
	/**
	 * getExternal Value for a status
	 */
	_getExternalValue: function(internalValue){
		var externalValue;
		if(this.woStatusSet){
			this.woStatusSet.forEach(function(domainrecord){
				if(domainrecord.defaults && domainrecord.maxvalue===internalValue){
		 	   		externalValue = domainrecord.value;
			   	}
			}); 
		}
		return externalValue;
	},
	/**
	 * Refresh attachment collection and set doclinks member and href
	 */
	refreshAttachmentCollection : function(recordHref){
		this.$.attachmentsCollection.collectionUri=recordHref;
		var self = this;
		this.$.attachmentsCollection.refreshRecords().then(function(records){
			var techWODetail = self.getTechWODetail();
			techWODetail._attachments = records.response.doclinks.member;
			techWODetail._doclinksUrl = records.response.doclinks.href;
			self.$.pages.select(1);
		});	
	},

	 /**
	  * To get new in memory workorder record and open technician detail page
	  */
    _getNewWorkorderData: function(e){
	   	$M.toggleWait(true);
	   	var lastSourcePage = '';
	   	if(e.target){
	   		lastSourcePage = e.target.id;
	   	}
	   	var object = {};
	   	var self = this;
		var collection = this.$.overduecollection;
	   	collection.addInternalValues = true;
    	collection.addLocalizedrep = true;
    	if(collection.additionalParams){
    		if(!collection.additionalParams.includes('ctx=app=WORK_EXECUTION')){
    	    	collection.additionalParams.push('ctx=app=WORK_EXECUTION');
    	    }
    	} else {
    		var additionalParams = [];
    		additionalParams.push('ctx=app=WORK_EXECUTION');
        	collection.additionalParams = additionalParams;
    	}
	   	collection.getNewRecord().then(function(result) {
    		Object.assign(object,result.response);
	   		object.site = {
	   	    		'description':$M.getMaxauth().whoami.defaultSiteDescription
	   	    	};
	   	    	object.siteid = result.response.siteid;
	   	    	object.reportedby = {
	       			'displayname': $M.userInfo.displayName,
	       			'_imagelibref': $M.userInfo._imagelibref,
	       			'personid': result.response.reportedby
	   	    	};
	   	    	object.uxsupervisor = {};
	   	    	object.status = result.response.status;
	   	    	object.status_maxvalue = result.response.status_maxvalue;
	   	    	object.status_description = result.response.status_description;
	   	    	object._uxsettings_={};
	   	    	object.reportdate_localized= object.reportdate_localized;
	   	    	object.href = $M.getMaxauth().baseUri + '/oslc/os/mxapiwodetail';
	   	    	object.wonum = result.response.wonum;
	   	    	object.workorderownergroup = (result.response.ownergroup) ? {'description':result.response.ownergroup} : {};
	   	    	object.ownerperson = (result.response.owner) ? {'displayname':result.response.owner} : {};
	    	    object.worktype =(result.response.worktype)?result.response.worktype:'';
				object.$alias_this_attr$location=(result.response.location)?result.response.location:'';
	    	    object.wo_worktype = {};
	    	    object.parent=(result.response.parent)?result.response.parent:{};
	    	    object.onbehalfof = (result.response.onbehalfof) ? {'displayname':result.response.onbehalfof} : {};
	    	    object.uxlead = (result.response.lead) ? {'displayname':result.response.lead} : {};
	    	    object.jobplan = {};
	    	    if(result.response.wopriority){
	    	    	object.wopriority = result.response.wopriority
	    	    }
	   	    	object.newMbo=true;
	   	    	self.fire('wo-detail', {'record': object, 'collection': collection, 'sourcePage': 'create', 'stopAnimation':true, 'newWO' : true,'lastSourcePage':lastSourcePage});
		 });
	  },
	  /**
	   * To fire a _cancelWorkorder function.
	   */
	  _cancelWorkorder : function(){
		  var techWODetail = this.getTechWODetail();
		  techWODetail._cancelWorkorder();
	   },
	  /**
	   * To fire a saveWorkorder function.
	   */
	   _saveWorkorder : function(){
		   var techWODetail = this.getTechWODetail();
		   techWODetail.saveWorkorder();
	   },
	   /**
	   * Toggle Complete Work Button on report work page.
	   */
	   _toggleCompleteButton : function(target, isVisible){
		   if($M.isMobile()){
			   $M.findElementParent(target,'MAXIMO-BUTTON').hidden = isVisible;
		   }else{
			   this.getReportWork().$.completeButtons.hidden = isVisible;
		   }
	   }
});
