<%--
* Licensed Materials - Property of IBM
* 
* 5724-U18
* 
* (C) COPYRIGHT IBM CORP. 2012, 2022 All Rights Reserved.
* 
* US Government Users Restricted Rights - Use, duplication or
* disclosure restricted by GSA ADP Schedule Contract with
* IBM Corp.
--%><%@ page contentType="text/html;charset=UTF-8" buffer="none"
%><%@page import="com.ibm.json.java.*"
%><%@page import="psdi.webclient.components.*"
%><%@page import="psdi.webclient.controls.*"
%><%@page import="psdi.webclient.controls.Menus"
%><%@page import="psdi.webclient.system.controller.*"
%><%@page import="psdi.webclient.system.runtime.*"
%><%@page import="psdi.webclient.system.session.*"
%><%@page import="psdi.webclient.system.session.WebClientSession.Alignment"
%><%ComponentInstance component = ComponentInstance.getCurrent(request);
	ControlInstance control = component.getControl();
	WebClientSession wcs = control.getWebClientSession();
	boolean accessibilityMode = wcs.getAccessibilityMode();
	boolean show = !wcs.getMobile() && (!component.getProperty("menutype").equals("goto") || 
			!control.getPage().getAppInstance().inAppLinkMode()); 
	if(show) {
		Alignment align = wcs.getAlignment();
		String imagePath = "";
		String id = ((BaseInstance)component).getRenderId().replaceAll("-","_"); //we need to make sure there are no '-' in the IDs
		String title = component.getProperty("title");
		boolean pageNav = control.getParentInstance().getBoolean("pagenav");
		String image = component.getProperty("image");
		boolean expanded = component.getBoolean("expanded");
		int sectionCount = control.getParentInstance().getChildCount();
		if(sectionCount==1) {
			expanded = true;
		}
		String icon = component.getProperty("icon");
		boolean showImages = component.getBoolean("showimages");
		boolean exclusive = component.getBoolean("exclusive");
		String height = component.getProperty("height");
		height = wcs.attachUOM(height);
		String display = "";
		if(!expanded && !accessibilityMode) {
			display = "none";
		}
		String maxPressed = expanded ? " aria-pressed='true' " : "";
        String minPressed = !expanded ? " aria-pressed='true' " : "";
		if(image.length() > 0) {
			image = "<img src='" + imagePath + "tasknav/" + image + "' style='margin: 3px;' alt=''/>";
		}

		String minimize = ((NavSection)component).minimize;
		String maximize = ((NavSection)component).maximize;
		String restore = ((NavSection)component).restore;
		String containerId = control.getParentInstance().getProperty("containerid");
		String ariaRole = control.getProperty("ariarole");
		if(accessibilityMode){
			ariaRole = "navigation";
		}
		
		if(component.needsRender()) {%>
		<div id="<%=id%>" class="navSection" role="<%=ariaRole%>" aria-labelledby="<%=id%>_label"  containerId="<%=containerId%>">
			<div class="navHeadOuter">
			<div id="<%=id%>_head" title="<%=title%>" role="presentation" style="width:100%" class="navHead" onkeyup="navHeadingKey(event,'<%=id%>')">
					<div style="display:inline;white-space: nowrap">
						<table role="presentation">
							<tr>
								<td>
									<<%if(accessibilityMode){%>h1<%}else{%>div<%}%> role="presentation" tabindex="0" ondblclick="toggleSectionState('<%=id%>');hideAllMenusNF();stopBubble(event);" id="<%=id%>_label" class="navTitle dojoxEllipsis" style="<%if(accessibilityMode){%>display: inline-block;<%}%>user-select: none;-moz-user-select: none;"><%=image%><%=title%></<%if(accessibilityMode){%>h1<%}else{%>div<%}%>>
								</td>
								<td>
							<%	if(sectionCount > 1) {	
									if(!accessibilityMode){ %>
									<div id="<%=id%>_min" class="hoverButton" style="vertical-align: top;float: <%=align.end%>;display:none;">
										<input id="<%=id%>_min_rest" class="navRestore" aria-label="<%=restore%>" title="<%=restore%>" alt="<%=restore%>" type="image" role="button" onkeypress="if(event.key == 'Enter'){event.target.click()}" onclick="toggleSectionView(this,'<%=id%>','normal');hideAllMenusNF();stopBubble(event);" src="<%=imagePath%>restore.gif" />
										<%if(pageNav){%>
											<input id="<%=id%>_min_max" aria-label="<%=maximize%>" title="<%=maximize%>" alt="<%=maximize%>" type="image" role="button" src="<%=imagePath%>maximize.gif" onkeypress="if(event.key == 'Enter'){event.target.click()}" onclick="toggleSectionView(this,'<%=id%>','max');hideAllMenusNF();stopBubble(event);"/>
										<%}%>
									</div>
									<div id="<%=id%>_max" class="hoverButton" style="vertical-align: top;float: <%=align.end%>;display:none">
										<input id="<%=id%>_max_min" aria-label="<%=minimize%>" title="<%=minimize%>" alt="<%=minimize%>" type="image" role="button" onkeypress="if(event.key == 'Enter'){event.target.click()}" onclick="toggleSectionView(this,'<%=id%>','min');hideAllMenusNF();stopBubble(event);" src="<%=imagePath%>minimize.gif" />
										<input id="<%=id%>_max_rest" class="navRestore" aria-label="<%=restore%>" title="<%=restore%>" alt="<%=restore%>" type="image" role="button" onkeypress="if(event.key == 'Enter'){event.target.click()}" onclick="previousSectionStates('<%=id%>');hideAllMenusNF();stopBubble(event);updateSectionIcons(dojo.byId('<%=id%>'));" src="<%=imagePath%>restore.gif" />
									</div>
									<div id="<%=id%>_normal" class="hoverButton" style="vertical-align: top;float: <%=align.end%>;display:none">
										<input id="<%=id%>_normal_min" aria-label="<%=minimize%>" title="<%=minimize%>" alt="<%=minimize%>" type="image" role="button" onkeypress="if(event.key == 'Enter'){event.target.click()}" onclick="toggleSectionView(this,'<%=id%>','min');hideAllMenusNF();stopBubble(event);" src="<%=imagePath%>minimize.gif" />
										<%if(pageNav){%>
											<input id="<%=id%>_normal_max" aria-label="<%=maximize%>" title="<%=maximize%>" alt="<%=maximize%>" type="image" role="button" onkeypress="if(event.key == 'Enter'){event.target.click()}" onclick="toggleSectionView(this,'<%=id%>','max');hideAllMenusNF();stopBubble(event);" src="<%=imagePath%>maximize.gif" />
										<%}%>
									</div>
								<%	}
									else { %>
									<div id="<%=id%>_hov" class="hoverButton" style="vertical-align: top;float: <%=align.end%>">
										<input id="<%=id%>_hov_min" aria-label="<%=minimize%>" <%=minPressed%> title="<%=minimize%>" alt="<%=minimize%>" type="image" role="button" onkeypress="if(event.key == 'Enter'){event.target.click()}" onclick="toggleSectionView(this,'<%=id%>','min');hideAllMenusNF();stopBubble(event);" src="<%=imagePath%>minimize.gif" />
										<input id="<%=id%>_hov_rest" class="navRestore" aria-label="<%=restore%>" title="<%=restore%>" alt="<%=restore%>" type="image" onkeypress="if(event.key == 'Enter'){event.target.click()}" role="button" onclick="toggleSectionView(this,'<%=id%>','normal');hideAllMenusNF();stopBubble(event);" src="<%=imagePath%>restore.gif" />
										<input id="<%=id%>_hov_max" aria-label="<%=maximize%>" <%=maxPressed%> title="<%=maximize%>" alt="<%=maximize%>" type="image" role="button" onkeypress="if(event.key == 'Enter'){event.target.click()}" onclick="toggleSectionView(this,'<%=id%>','max');hideAllMenusNF();stopBubble(event);" src="<%=imagePath%>maximize.gif" />
									</div> <%} }%>
								</td>
							</tr>
						</table>
					</div>
				</div>
			</div>
	<%	}
		String dataString = ((NavSection)component).getDataString();
		boolean needsClose = false;
		if(!wcs.getDesignmode())
		{	
			if(component.needsRender()) {%>
			<div id="<%=id%>_content" style="display:<%=display%>;" class="navContent"	 tabindex="-1">
				<div id="<%=id%>_content_inner">
				</div>
			</div>
			<%}
			else if(component.hasChanged()){ 
			%><component id="<%=id%>_holder" compid="<%=id%>"><%="<![CDATA["%><%
				needsClose = true;
			}	
			if(component.needsRender() || component.hasChanged()) { %>
			<script type="text/javascript">
			<%  boolean tryCache = (component.getProperty("datasrcid").equalsIgnoreCase("menus") && component.getProperty("menutype").equals("goto")); 
				boolean isQuery = component.getProperty("menutype").equals("query"); %>
				var state<%=id%> = "<%if(expanded){%>normal<%}else{%>min<%}%>";
				if(<%=containerId%>navSections["<%=id%>"]) {
					state<%=id%> = <%=containerId%>navSections["<%=id%>"]["state"];
				}
				<%=containerId%>navSections["<%=id%>"]={"height":"<%=height%>","state":state<%=id%>,"loaded":false};
				<%=containerId%>navSectionsOrder.push("<%=id%>");
				fillNavSection(<%=dataString%>, {"labelledBy":"<%=id%>_label","args":{"content":{"events": dojo.toJson([{"navSectionId":"<%=id%>","containerId" : "<%=containerId%>","classname":"ns_<%=component.getProperty("menutype")%>","showImages" : "<%=showImages%>","isQuery" : "<%=isQuery%>","render" : "true"}])}}});
				</script>
		<%	}	
		}
		else if(component.needsRender())
		{	%>
			<div style="height: 40px">
				&nbsp;
			</div> 
	<%	}
		if(component.needsRender()) {%>
	</div>
	<%	}
		else if(needsClose){
			%>]]></component><%
		}
	}	%>
